/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Xapian.xs. Do not edit this file, edit Xapian.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Xapian.xs"
// Disable any deprecation warnings for Xapian methods/functions/classes.
#define XAPIAN_DEPRECATED(D) D
#include <xapian.h>

/* Dummy definition for Xapian < 1.4.2. */
#ifndef XAPIAN_AT_LEAST
# define XAPIAN_AT_LEAST(X,Y,Z) 0
#endif

#include <string>
#include <vector>

// Stop Perl headers from even thinking of doing '#define bool char' or
// '#define bool int', which they would do with compilers other than GCC.
#define HAS_BOOL

extern "C" {
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
}

/* Perl's embed.h defines get_context, but that mangles
 * Xapian::Error::get_context(). */
#ifdef get_context
# undef get_context
#endif

using namespace std;
using namespace Xapian;

// For some classes, we want extra slots to keep references to set objects in.

struct Enquire_perl {
    Enquire real_obj;
    SV * sorter;
    vector<SV *> matchspies;

    Enquire_perl(const Xapian::Database & db) : real_obj(db), sorter(NULL) { }

    void ref_sorter(SV * sv) {
	SvREFCNT_inc(sv);
	swap(sv, sorter);
	SvREFCNT_dec(sv);
    }

    void ref_matchspy(SV* sv) {
	SvREFCNT_inc(sv);
	matchspies.push_back(sv);
    }

    void ref_clear_matchspies(SV* sv) {
	vector<SV *>::const_iterator i;
	for (i = matchspies.begin(); i != matchspies.end(); ++i) {
	    SvREFCNT_dec(*i);
	}
	matchspies.clear();
    }

    ~Enquire_perl() {
	SvREFCNT_dec(sorter);
	sorter = NULL;
	ref_clear_matchspies(NULL);
    }
};

struct QueryParser_perl {
    QueryParser real_obj;
    SV * stopper;
    vector<SV *> vrps;

    QueryParser_perl() : real_obj(), stopper(NULL) { }

    void ref_stopper(SV * sv) {
	SvREFCNT_inc(sv);
	swap(sv, stopper);
	SvREFCNT_dec(sv);
    }

    void ref_vrp(SV * sv) {
	SvREFCNT_inc(sv);
	vrps.push_back(sv);
    }

    ~QueryParser_perl() {
	SvREFCNT_dec(stopper);
	stopper = NULL;
	vector<SV *>::const_iterator i;
	for (i = vrps.begin(); i != vrps.end(); ++i) {
	    SvREFCNT_dec(*i);
	}
	vrps.clear();
    }
};

struct TermGenerator_perl {
    TermGenerator real_obj;
    SV * stopper;

    TermGenerator_perl() : real_obj(), stopper(NULL) { }

    void ref_stopper(SV * sv) {
	SvREFCNT_inc(sv);
	swap(sv, stopper);
	SvREFCNT_dec(sv);
    }

    ~TermGenerator_perl() {
	SvREFCNT_dec(stopper);
	stopper = NULL;
    }
};

#define XAPIAN_PERL_NEW(CLASS, PARAMS) (&((new CLASS##_perl PARAMS)->real_obj))
#define XAPIAN_PERL_CAST(CLASS, OBJ) ((CLASS##_perl*)(void*)(OBJ))
#define XAPIAN_PERL_REF(CLASS, OBJ, MEMB, SV) XAPIAN_PERL_CAST(CLASS, OBJ)->ref_##MEMB(SV)
#define XAPIAN_PERL_DESTROY(CLASS, OBJ) delete XAPIAN_PERL_CAST(CLASS, OBJ)

extern void handle_exception(void);

/* PerlStopper class
 *
 * Make operator() call Perl $OBJECT->stop_word
 */

class PerlStopper : public Stopper {
    public:
	PerlStopper(SV * obj) { SV_stopper_ref = newRV_inc(obj); }
	~PerlStopper() { sv_2mortal(SV_stopper_ref); }
	bool operator()(const string &term) const {
	    dSP ;

	    ENTER ;
	    SAVETMPS ;

	    PUSHMARK(SP);
	    PUSHs(SvRV(SV_stopper_ref));
	    PUSHs(sv_2mortal(newSVpv(term.data(), term.size())));
	    PUTBACK ;

	    int count = call_method("stop_word", G_SCALAR);

	    SPAGAIN ;

	    if (count != 1)
		croak("callback function should return 1 value, got %d", count);

	    // Breaks with SvTRUE(POPs) ?!?!?!
	    bool r = SvTRUE(SP[0]);
	    POPs ;

	    PUTBACK ;
	    FREETMPS ;
	    LEAVE ;

	    return r;
	}

    private:
	SV * SV_stopper_ref;
};

class perlMatchDecider : public Xapian::MatchDecider {
    SV *callback;

  public:
    perlMatchDecider(SV *func) {
	callback = newSVsv(func);
    }

    ~perlMatchDecider() {
	SvREFCNT_dec(callback);
    }

    bool operator()(const Xapian::Document &doc) const {
	dSP;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);

	SV *arg = sv_newmortal();

	Document *pdoc = new Document(doc);
	sv_setref_pv(arg, "Search::Xapian::Document", (void *)pdoc);
	XPUSHs(arg);

	PUTBACK;

	int count = call_sv(callback, G_SCALAR);

	SPAGAIN;
	if (count != 1)
	    croak("callback function should return 1 value, got %d", count);

	int decide_actual_result = POPi;

	PUTBACK;

	FREETMPS;
	LEAVE;

	return decide_actual_result;
    }
};

class perlExpandDecider : public Xapian::ExpandDecider {
    SV *callback;

  public:
    perlExpandDecider(SV *func) {
	callback = newSVsv(func);
    }

    ~perlExpandDecider() {
	SvREFCNT_dec(callback);
    }

    bool operator()(const string &term) const {
	dSP;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);

	XPUSHs(sv_2mortal(newSVpv(term.data(), term.size())));

	PUTBACK;

	int count = call_sv(callback, G_SCALAR);

	SPAGAIN;
	if (count != 1)
	    croak("callback function should return 1 value, got %d", count);

	int decide_actual_result = POPi;

	PUTBACK;

	FREETMPS;
	LEAVE;

	return decide_actual_result;
    }
};


#line 260 "Xapian.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 404 "Xapian.c"

XS_EUPXS(XS_Search__Xapian_sortable_serialise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian_sortable_serialise)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "value");
    {
	string	RETVAL;
	dXSTARG;
	double	value = (double)SvNV(ST(0))
;

	RETVAL = sortable_serialise(value);
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian_sortable_unserialise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian_sortable_unserialise)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "value");
    {
	double	RETVAL;
	dXSTARG;
	string	value;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(0), len);
		value.assign(tmp, len);
	}
;

	RETVAL = sortable_unserialise(value);
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian_version_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian_version_string)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = version_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian_major_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian_major_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = major_version();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian_minor_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian_minor_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = minor_version();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian_revision); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian_revision)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = revision();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE:  Including 'XS/BM25Weight.xs' from 'Xapian.xs' */


/* INCLUDE:  Including 'XS/BoolWeight.xs' from 'XS/BM25Weight.xs' */


/* INCLUDE:  Including 'XS/Database.xs' from 'XS/BoolWeight.xs' */


/* INCLUDE:  Including 'XS/Document.xs' from 'XS/Database.xs' */


/* INCLUDE:  Including 'XS/Enquire.xs' from 'XS/Document.xs' */


/* INCLUDE:  Including 'XS/MSet.xs' from 'XS/Enquire.xs' */


/* INCLUDE:  Including 'XS/MSetIterator.xs' from 'XS/MSet.xs' */


/* INCLUDE:  Including 'XS/ESet.xs' from 'XS/MSetIterator.xs' */


/* INCLUDE:  Including 'XS/Error.xs' from 'XS/ESet.xs' */


/* INCLUDE:  Including 'XS/ESetIterator.xs' from 'XS/Error.xs' */


/* INCLUDE:  Including 'XS/RSet.xs' from 'XS/ESetIterator.xs' */


/* INCLUDE:  Including 'XS/MultiValueSorter.xs' from 'XS/RSet.xs' */


/* INCLUDE:  Including 'XS/Query.xs' from 'XS/MultiValueSorter.xs' */


/* INCLUDE:  Including 'XS/QueryParser.xs' from 'XS/Query.xs' */


/* INCLUDE:  Including 'XS/SimpleStopper.xs' from 'XS/QueryParser.xs' */


/* INCLUDE:  Including 'XS/Stem.xs' from 'XS/SimpleStopper.xs' */


/* INCLUDE:  Including 'XS/Stopper.xs' from 'XS/Stem.xs' */


/* INCLUDE:  Including 'XS/TermGenerator.xs' from 'XS/Stopper.xs' */


/* INCLUDE:  Including 'XS/TermIterator.xs' from 'XS/TermGenerator.xs' */


/* INCLUDE:  Including 'XS/TradWeight.xs' from 'XS/TermIterator.xs' */


/* INCLUDE:  Including 'XS/PostingIterator.xs' from 'XS/TradWeight.xs' */


/* INCLUDE:  Including 'XS/PositionIterator.xs' from 'XS/PostingIterator.xs' */


/* INCLUDE:  Including 'XS/ValueIterator.xs' from 'XS/PositionIterator.xs' */


/* INCLUDE:  Including 'XS/WritableDatabase.xs' from 'XS/ValueIterator.xs' */


/* INCLUDE:  Including 'XS/Weight.xs' from 'XS/WritableDatabase.xs' */


/* INCLUDE: Returning to 'XS/WritableDatabase.xs' from 'XS/Weight.xs' */


XS_EUPXS(XS_Search__Xapian__WritableDatabase_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_new1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "file, opts");
    {
	string	file;
	int	opts = (int)SvIV(ST(1))
;
	WritableDatabase *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(0), len);
		file.assign(tmp, len);
	}
;
#line 10 "./XS/WritableDatabase.xs"
	try {
	    RETVAL = new WritableDatabase(file, opts);
	} catch (...) {
	    handle_exception();
	}
#line 627 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::WritableDatabase", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "database");
    {
	WritableDatabase *	database;
	WritableDatabase *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		database = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::new2() -- database is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 22 "./XS/WritableDatabase.xs"
	RETVAL = new WritableDatabase(*database);
#line 658 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::WritableDatabase", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_new3); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_new3)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	WritableDatabase *	RETVAL;
#line 29 "./XS/WritableDatabase.xs"
	try {
#if XAPIAN_AT_LEAST(1,5,0)
	    RETVAL = new WritableDatabase(std::string(), Xapian::DB_BACKEND_INMEMORY);
#else
	    RETVAL = new WritableDatabase(InMemory::open());
#endif
	} catch (...) {
	    handle_exception();
	}
#line 688 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::WritableDatabase", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WritableDatabase *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::flush() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 44 "./XS/WritableDatabase.xs"
	try {
	    THIS->commit();
	} catch (...) {
	    handle_exception();
	}
#line 722 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_commit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WritableDatabase *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::commit() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 53 "./XS/WritableDatabase.xs"
	try {
	    THIS->commit();
	} catch (...) {
	    handle_exception();
	}
#line 750 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_begin_transaction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_begin_transaction)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, flushed = NO_INIT");
    {
	bool	flushed;
	WritableDatabase *	THIS;

	if (items >= 2) {
	    flushed = (bool)SvTRUE(ST(1))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::begin_transaction() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 63 "./XS/WritableDatabase.xs"
	try {
	    if (items == 2) { /* items includes the hidden this pointer */
		THIS->begin_transaction(flushed);
	    } else {
		THIS->begin_transaction();
	    }
	} catch (...) {
	    handle_exception();
	}
#line 788 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_commit_transaction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_commit_transaction)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WritableDatabase *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::commit_transaction() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 76 "./XS/WritableDatabase.xs"
	try {
	    THIS->commit_transaction();
	} catch (...) {
	    handle_exception();
	}
#line 816 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_cancel_transaction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_cancel_transaction)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WritableDatabase *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::cancel_transaction() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 85 "./XS/WritableDatabase.xs"
	try {
	    THIS->cancel_transaction();
	} catch (...) {
	    handle_exception();
	}
#line 844 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_add_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_add_document)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, document");
    {
	Document *	document;
	WritableDatabase *	THIS;
	docid	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Document") )
		document = (Document *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::WritableDatabase::add_document() -- document is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::add_document() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 95 "./XS/WritableDatabase.xs"
	try {
	    RETVAL = THIS->add_document(*document);
	} catch (...) {
	    handle_exception();
	}
#line 883 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_delete_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_delete_document)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	docid	did = (docid)SvUV(ST(1))
;
	WritableDatabase *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::delete_document() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 107 "./XS/WritableDatabase.xs"
	try {
	    THIS->delete_document(did);
	} catch (...) {
	    handle_exception();
	}
#line 915 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_delete_document_by_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_delete_document_by_term)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, unique_term");
    {
	string	unique_term;
	WritableDatabase *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		unique_term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::delete_document_by_term() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 117 "./XS/WritableDatabase.xs"
	try {
	    THIS->delete_document(unique_term);
	} catch (...) {
	    handle_exception();
	}
#line 951 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_replace_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_replace_document)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, did, document");
    {
	docid	did = (docid)SvUV(ST(1))
;
	Document *	document;
	WritableDatabase *	THIS;

	if( sv_isobject(ST(2)) && sv_derived_from(ST(2), "Search::Xapian::Document") )
		document = (Document *)SvIV((SV*)SvRV( ST(2) ));
	else{
		warn( "Search::Xapian::WritableDatabase::replace_document() -- document is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::replace_document() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 128 "./XS/WritableDatabase.xs"
	try {
	    THIS->replace_document(did, *document);
	} catch (...) {
	    handle_exception();
	}
#line 990 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_replace_document_by_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_replace_document_by_term)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, unique_term, document");
    {
	string	unique_term;
	Document *	document;
	WritableDatabase *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		unique_term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(2)) && sv_derived_from(ST(2), "Search::Xapian::Document") )
		document = (Document *)SvIV((SV*)SvRV( ST(2) ));
	else{
		warn( "Search::Xapian::WritableDatabase::replace_document_by_term() -- document is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::replace_document_by_term() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 139 "./XS/WritableDatabase.xs"
	try {
	    THIS->replace_document(unique_term, *document);
	} catch (...) {
	    handle_exception();
	}
#line 1035 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_set_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_set_metadata)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, key, value");
    {
	WritableDatabase *	THIS;
	string	key;
	string	value;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::set_metadata() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		key.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		value.assign(tmp, len);
	}
;
#line 148 "./XS/WritableDatabase.xs"
	try {
	    THIS->set_metadata(key, value);
	} catch (...) {
	    handle_exception();
	}
#line 1079 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WritableDatabase *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::DESTROY() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_add_synonym); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_add_synonym)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, term, synonym");
    {
	WritableDatabase *	THIS;
	string	term;
	string	synonym;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::add_synonym() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		synonym.assign(tmp, len);
	}
;
#line 160 "./XS/WritableDatabase.xs"
	try {
	    THIS->add_synonym(term, synonym);
	} catch (...) {
	    handle_exception();
	}
#line 1146 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_remove_synonym); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_remove_synonym)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, term, synonym");
    {
	WritableDatabase *	THIS;
	string	term;
	string	synonym;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::remove_synonym() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		synonym.assign(tmp, len);
	}
;
#line 169 "./XS/WritableDatabase.xs"
	try {
	    THIS->remove_synonym(term, synonym);
	} catch (...) {
	    handle_exception();
	}
#line 1190 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_clear_synonyms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_clear_synonyms)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	WritableDatabase *	THIS;
	string	term;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::clear_synonyms() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;
#line 178 "./XS/WritableDatabase.xs"
	try {
	    THIS->clear_synonyms(term);
	} catch (...) {
	    handle_exception();
	}
#line 1226 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_add_spelling); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_add_spelling)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, word, freqinc = 1");
    {
	string	word;
	termcount	freqinc;
	WritableDatabase *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		word.assign(tmp, len);
	}
;

	if (items < 3)
	    freqinc = 1;
	else {
	    freqinc = (termcount)SvUV(ST(2))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::add_spelling() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 189 "./XS/WritableDatabase.xs"
	try {
	    THIS->add_spelling(word, freqinc);
	} catch (...) {
	    handle_exception();
	}
#line 1270 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__WritableDatabase_remove_spelling); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WritableDatabase_remove_spelling)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, word, freqdec  = 1");
    {
	string	word;
	termcount	freqdec;
	WritableDatabase *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		word.assign(tmp, len);
	}
;

	if (items < 3)
	    freqdec = 1;
	else {
	    freqdec = (termcount)SvUV(ST(2))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::WritableDatabase") )
		THIS = (WritableDatabase *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WritableDatabase::remove_spelling() -- THIS is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;
#line 200 "./XS/WritableDatabase.xs"
	try {
	    THIS->remove_spelling(word, freqdec);
	} catch (...) {
	    handle_exception();
	}
#line 1314 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/ValueIterator.xs' from 'XS/WritableDatabase.xs' */


XS_EUPXS(XS_Search__Xapian__ValueIterator_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	ValueIterator *	RETVAL;
#line 8 "./XS/ValueIterator.xs"
	RETVAL = new ValueIterator();
#line 1333 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ValueIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	ValueIterator *	other;
	ValueIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		other = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::new2() -- other is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/ValueIterator.xs"
	RETVAL = new ValueIterator(*other);
#line 1364 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ValueIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		THIS = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::DESTROY() -- THIS is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_inc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		THIS = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::inc() -- THIS is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 26 "./XS/ValueIterator.xs"
	++(*THIS);
#line 1417 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_equal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	ValueIterator *	that;
	ValueIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::ValueIterator") )
		that = (ValueIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::ValueIterator::equal() -- that is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		THIS = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::equal() -- THIS is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 32 "./XS/ValueIterator.xs"
	RETVAL = ((*THIS) == (*that));
#line 1451 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_nequal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_nequal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	ValueIterator *	that;
	ValueIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::ValueIterator") )
		that = (ValueIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::ValueIterator::nequal() -- that is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		THIS = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::nequal() -- THIS is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 40 "./XS/ValueIterator.xs"
	RETVAL = ((*THIS) != (*that));
#line 1486 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_get_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_get_value)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		THIS = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::get_value() -- THIS is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 47 "./XS/ValueIterator.xs"
	RETVAL = THIS->operator*();
#line 1513 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_get_valueno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_get_valueno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueIterator *	THIS;
	valueno	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		THIS = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::get_valueno() -- THIS is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_valueno();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueIterator_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueIterator_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ValueIterator") )
		THIS = (ValueIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueIterator::get_description() -- THIS is not a \"Search::Xapian::ValueIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'XS/PositionIterator.xs' from 'XS/ValueIterator.xs' */


XS_EUPXS(XS_Search__Xapian__PositionIterator_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	PositionIterator *	RETVAL;
#line 8 "./XS/PositionIterator.xs"
	RETVAL = new PositionIterator();
#line 1588 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	PositionIterator *	other;
	PositionIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		other = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::new2() -- other is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/PositionIterator.xs"
	RETVAL = new PositionIterator(*other);
#line 1619 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PositionIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		THIS = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::DESTROY() -- THIS is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_inc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PositionIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		THIS = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::inc() -- THIS is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 26 "./XS/PositionIterator.xs"
	++(*THIS);
#line 1672 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_equal1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_equal1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	PositionIterator *	that;
	PositionIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::PositionIterator") )
		that = (PositionIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::PositionIterator::equal1() -- that is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		THIS = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::equal1() -- THIS is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 32 "./XS/PositionIterator.xs"
	RETVAL = ((*THIS) == (*that));
#line 1706 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_nequal1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_nequal1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	PositionIterator *	that;
	PositionIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::PositionIterator") )
		that = (PositionIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::PositionIterator::nequal1() -- that is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		THIS = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::nequal1() -- THIS is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 40 "./XS/PositionIterator.xs"
	RETVAL = ((*THIS) != (*that));
#line 1741 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_get_termpos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_get_termpos)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PositionIterator *	THIS;
	termpos	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		THIS = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::get_termpos() -- THIS is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 47 "./XS/PositionIterator.xs"
	RETVAL = THIS->operator*();
#line 1768 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_skip_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_skip_to)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, pos");
    {
	PositionIterator *	THIS;
	termpos	pos = (termpos)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		THIS = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::skip_to() -- THIS is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	THIS->skip_to(pos);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__PositionIterator_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PositionIterator_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PositionIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PositionIterator") )
		THIS = (PositionIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PositionIterator::get_description() -- THIS is not a \"Search::Xapian::PositionIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'XS/PostingIterator.xs' from 'XS/PositionIterator.xs' */


XS_EUPXS(XS_Search__Xapian__PostingIterator_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	PostingIterator *	RETVAL;
#line 8 "./XS/PostingIterator.xs"
	RETVAL = new PostingIterator();
#line 1841 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PostingIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	PostingIterator *	other;
	PostingIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		other = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::new2() -- other is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/PostingIterator.xs"
	RETVAL = new PostingIterator(*other);
#line 1872 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PostingIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::DESTROY() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_inc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::inc() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 26 "./XS/PostingIterator.xs"
	++(*THIS);
#line 1925 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_equal1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_equal1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	PostingIterator *	that;
	PostingIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::PostingIterator") )
		that = (PostingIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::PostingIterator::equal1() -- that is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::equal1() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 32 "./XS/PostingIterator.xs"
	RETVAL = ((*THIS) == (*that));
#line 1959 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_nequal1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_nequal1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	PostingIterator *	that;
	PostingIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::PostingIterator") )
		that = (PostingIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::PostingIterator::nequal1() -- that is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::nequal1() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 40 "./XS/PostingIterator.xs"
	RETVAL = ((*THIS) != (*that));
#line 1994 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_get_docid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_get_docid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;
	docid	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::get_docid() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 47 "./XS/PostingIterator.xs"
	RETVAL = THIS->operator*();
#line 2021 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_get_doclength); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_get_doclength)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;
	doclength	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::get_doclength() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 54 "./XS/PostingIterator.xs"
	RETVAL = THIS->get_doclength();
#line 2049 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_get_wdf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_get_wdf)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::get_wdf() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 61 "./XS/PostingIterator.xs"
	RETVAL = THIS->get_wdf();
#line 2077 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::get_description() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_positionlist_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_positionlist_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;
	PositionIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::positionlist_begin() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 71 "./XS/PostingIterator.xs"
	RETVAL = new PositionIterator(THIS->positionlist_begin());
#line 2131 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_positionlist_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_positionlist_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	PostingIterator *	THIS;
	PositionIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::positionlist_end() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 78 "./XS/PostingIterator.xs"
	RETVAL = new PositionIterator(THIS->positionlist_end());
#line 2162 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__PostingIterator_skip_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__PostingIterator_skip_to)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, pos");
    {
	PostingIterator *	THIS;
	docid	pos = (docid)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::PostingIterator") )
		THIS = (PostingIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::PostingIterator::skip_to() -- THIS is not a \"Search::Xapian::PostingIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	THIS->skip_to(pos);
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/TradWeight.xs' from 'XS/PostingIterator.xs' */


XS_EUPXS(XS_Search__Xapian__TradWeight_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TradWeight_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	TradWeight *	RETVAL;
#line 8 "./XS/TradWeight.xs"
	RETVAL = new TradWeight();
#line 2212 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Weight", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TradWeight_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TradWeight_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "k");
    {
	double	k = (double)SvNV(ST(0))
;
	TradWeight *	RETVAL;
#line 16 "./XS/TradWeight.xs"
	RETVAL = new TradWeight(k);
#line 2236 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Weight", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TradWeight_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TradWeight_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TradWeight *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Weight") )
		THIS = (TradWeight *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TradWeight::DESTROY() -- THIS is not a \"Search::Xapian::Weight\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/TermIterator.xs' from 'XS/TradWeight.xs' */


XS_EUPXS(XS_Search__Xapian__TermIterator_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	TermIterator *	RETVAL;
#line 8 "./XS/TermIterator.xs"
	RETVAL = new TermIterator();
#line 2284 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	TermIterator *	other;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		other = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::new2() -- other is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/TermIterator.xs"
	RETVAL = new TermIterator(*other);
#line 2315 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::DESTROY() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermIterator_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_inc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::inc() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 26 "./XS/TermIterator.xs"
	RETVAL = new TermIterator(++(*THIS));
#line 2369 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_equal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	TermIterator *	that;
	TermIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::TermIterator") )
		that = (TermIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::TermIterator::equal() -- that is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::equal() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 34 "./XS/TermIterator.xs"
	RETVAL = ((*THIS) == (*that));
#line 2409 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_nequal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_nequal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	TermIterator *	that;
	TermIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::TermIterator") )
		that = (TermIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::TermIterator::nequal() -- that is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::nequal() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 42 "./XS/TermIterator.xs"
	RETVAL = ((*THIS) != (*that));
#line 2444 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_get_termname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_get_termname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::get_termname() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 49 "./XS/TermIterator.xs"
	RETVAL = THIS->operator*();
#line 2471 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_skip_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_skip_to)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	TermIterator *	THIS;
	string	tname;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::skip_to() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	THIS->skip_to(tname);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermIterator_get_wdf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_get_wdf)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::get_wdf() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_wdf();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_get_termfreq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_get_termfreq)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::get_termfreq() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_termfreq();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_positionlist_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_positionlist_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;
	PositionIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::positionlist_begin() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 65 "./XS/TermIterator.xs"
	RETVAL = new PositionIterator(THIS->positionlist_begin());
#line 2583 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_positionlist_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_positionlist_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;
	PositionIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::positionlist_end() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 72 "./XS/TermIterator.xs"
	RETVAL = new PositionIterator(THIS->positionlist_end());
#line 2614 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermIterator_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermIterator_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermIterator") )
		THIS = (TermIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermIterator::get_description() -- THIS is not a \"Search::Xapian::TermIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'XS/TermGenerator.xs' from 'XS/TermIterator.xs' */


XS_EUPXS(XS_Search__Xapian__TermGenerator_new0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_new0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	TermGenerator *	RETVAL;
#line 8 "./XS/TermGenerator.xs"
	RETVAL = XAPIAN_PERL_NEW(TermGenerator, ());
#line 2666 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermGenerator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_set_stemmer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_set_stemmer)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, stemmer");
    {
	Stem *	stemmer;
	TermGenerator *	THIS;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		stemmer = (Stem *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_stemmer() -- stemmer is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_stemmer() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/TermGenerator.xs"
	THIS->set_stemmer(*stemmer);
#line 2705 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_set_stopper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_set_stopper)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, stopper");
    {
	Stopper *	stopper;
	TermGenerator *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Stopper") )
		stopper = (Stopper *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_stopper() -- stopper is not a \"Search::Xapian::Stopper\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_stopper() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 22 "./XS/TermGenerator.xs"
	// Keep a reference to the currently set object.
	XAPIAN_PERL_REF(TermGenerator, THIS, stopper, ST(1));
	THIS->set_stopper(stopper);
#line 2740 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_set_database); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_set_database)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, db");
    {
	WritableDatabase *	db;
	TermGenerator *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::WritableDatabase") )
		db = (WritableDatabase *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_database() -- db is not a \"Search::Xapian::WritableDatabase\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_database() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 30 "./XS/TermGenerator.xs"
	THIS->set_database(*db);
#line 2773 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_set_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_set_document)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, doc");
    {
	TermGenerator *	THIS;
	Document *	doc;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_document() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Document") )
		doc = (Document *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_document() -- doc is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 35 "./XS/TermGenerator.xs"
	THIS->set_document(*doc);
#line 2806 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_get_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_get_document)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermGenerator *	THIS;
	Document *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::get_document() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 40 "./XS/TermGenerator.xs"
	RETVAL = new Document(THIS->get_document());
#line 2831 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Document", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_index_text); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_index_text)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "THIS, text, weight = 1, prefix = NO_INIT");
    {
	string	text;
	termcount	weight;
	string	prefix;
	TermGenerator *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		text.assign(tmp, len);
	}
;

	if (items < 3)
	    weight = 1;
	else {
	    weight = (termcount)SvUV(ST(2))
;
	}

	if (items >= 4) {
	    {
		    STRLEN len;
		    const char * tmp = SvPV(ST(3), len);
		    prefix.assign(tmp, len);
	    }
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::index_text() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	THIS->index_text(text, weight, prefix);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_set_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_set_flags)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, toggle, mask= 0");
    {
	TermGenerator *	THIS;
	int	RETVAL;
	dXSTARG;
	int	toggle = (int)SvIV(ST(1))
;
	int	mask;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_flags() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	if (items < 3)
	    mask = 0;
	else {
	    mask = (int)SvIV(ST(2))
;
	}
#line 53 "./XS/TermGenerator.xs"
	RETVAL = THIS->set_flags(TermGenerator::flags(toggle),
				 TermGenerator::flags(mask));
#line 2923 "Xapian.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_index_text_without_positions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_index_text_without_positions)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "THIS, text, weight = 1, prefix = NO_INIT");
    {
	string	text;
	termcount	weight;
	string	prefix;
	TermGenerator *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		text.assign(tmp, len);
	}
;

	if (items < 3)
	    weight = 1;
	else {
	    weight = (termcount)SvUV(ST(2))
;
	}

	if (items >= 4) {
	    {
		    STRLEN len;
		    const char * tmp = SvPV(ST(3), len);
		    prefix.assign(tmp, len);
	    }
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::index_text_without_positions() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	THIS->index_text_without_positions(text, weight, prefix);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_increase_termpos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_increase_termpos)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, delta= 100");
    {
	TermGenerator *	THIS;
	termcount	delta;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::increase_termpos() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	if (items < 2)
	    delta = 100;
	else {
	    delta = (termcount)SvUV(ST(1))
;
	}

	THIS->increase_termpos(delta);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_get_termpos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_get_termpos)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermGenerator *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::get_termpos() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_termpos();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_set_termpos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_set_termpos)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, termpos");
    {
	TermGenerator *	THIS;
	termcount	termpos = (termcount)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::set_termpos() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	THIS->set_termpos(termpos);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermGenerator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::get_description() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__TermGenerator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__TermGenerator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	TermGenerator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::TermGenerator") )
		THIS = (TermGenerator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::TermGenerator::DESTROY() -- THIS is not a \"Search::Xapian::TermGenerator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 79 "./XS/TermGenerator.xs"
	XAPIAN_PERL_DESTROY(TermGenerator, THIS);
#line 3108 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/Stopper.xs' from 'XS/TermGenerator.xs' */


XS_EUPXS(XS_Search__Xapian__Stopper_stop_word); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Stopper_stop_word)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	string	term;
	Stopper *	THIS;
	bool	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Stopper") )
		THIS = (Stopper *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Stopper::stop_word() -- THIS is not a \"Search::Xapian::Stopper\" object" );
		XSRETURN_UNDEF;
	}
;
#line 9 "./XS/Stopper.xs"
		RETVAL = (*THIS)(term);
#line 3144 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Stopper_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Stopper_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Stopper *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Stopper") )
		THIS = (Stopper *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Stopper::DESTROY() -- THIS is not a \"Search::Xapian::Stopper\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/Stem.xs' from 'XS/Stopper.xs' */


XS_EUPXS(XS_Search__Xapian__Stem_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Stem_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, language");
    {
	string	language;
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	Stem *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		language.assign(tmp, len);
	}
;
#line 9 "./XS/Stem.xs"
	try {
	    RETVAL = new Stem(language);
	} catch (...) {
	    handle_exception();
	}
#line 3201 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Stem_stem_word); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Stem_stem_word)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, word");
    {
	Stem *	THIS;
	string	RETVAL;
	dXSTARG;
	string	word;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Stem *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Stem::stem_word() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		word.assign(tmp, len);
	}
;
#line 20 "./XS/Stem.xs"
	RETVAL = (*THIS)(word);
#line 3241 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Stem_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Stem_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Stem *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Stem *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Stem::get_description() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Stem_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Stem_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Stem *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Stem *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Stem::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/SimpleStopper.xs' from 'XS/Stem.xs' */


XS_EUPXS(XS_Search__Xapian__SimpleStopper_new0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SimpleStopper_new0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SimpleStopper *	RETVAL;
#line 8 "./XS/SimpleStopper.xs"
	RETVAL = new SimpleStopper();
#line 3312 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::SimpleStopper", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__SimpleStopper_stop_word); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SimpleStopper_stop_word)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	string	term;
	SimpleStopper *	THIS;
	bool	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::SimpleStopper") )
		THIS = (SimpleStopper *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SimpleStopper::stop_word() -- THIS is not a \"Search::Xapian::SimpleStopper\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/SimpleStopper.xs"
	RETVAL = (*THIS)(term);
#line 3351 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__SimpleStopper_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SimpleStopper_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	SimpleStopper *	THIS;
	string	term;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::SimpleStopper") )
		THIS = (SimpleStopper *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SimpleStopper::add() -- THIS is not a \"Search::Xapian::SimpleStopper\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	THIS->add(term);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__SimpleStopper_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SimpleStopper_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	SimpleStopper *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::SimpleStopper") )
		THIS = (SimpleStopper *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SimpleStopper::DESTROY() -- THIS is not a \"Search::Xapian::SimpleStopper\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/QueryParser.xs' from 'XS/SimpleStopper.xs' */


XS_EUPXS(XS_Search__Xapian__QueryParser_new0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_new0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	QueryParser *	RETVAL;
#line 8 "./XS/QueryParser.xs"
	RETVAL = XAPIAN_PERL_NEW(QueryParser, ());
#line 3425 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::QueryParser", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_set_stemmer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_set_stemmer)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, stemmer");
    {
	Stem *	stemmer;
	QueryParser *	THIS;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		stemmer = (Stem *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::QueryParser::set_stemmer() -- stemmer is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::set_stemmer() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/QueryParser.xs"
	THIS->set_stemmer(*stemmer);
#line 3464 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_set_stemming_strategy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_set_stemming_strategy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, strategy");
    {
	int	strategy = (int)SvIV(ST(1))
;
	QueryParser *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::set_stemming_strategy() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 22 "./XS/QueryParser.xs"
	THIS->set_stemming_strategy(static_cast<QueryParser::stem_strategy>(strategy));
#line 3490 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_set_stopper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_set_stopper)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, stopper");
    {
	Stopper *	stopper;
	QueryParser *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Stopper") )
		stopper = (Stopper *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::QueryParser::set_stopper() -- stopper is not a \"Search::Xapian::Stopper\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::set_stopper() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 28 "./XS/QueryParser.xs"
	// Keep a reference to the currently set object.
	XAPIAN_PERL_REF(QueryParser, THIS, stopper, ST(1));
	THIS->set_stopper(stopper);
#line 3525 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_set_default_op); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_set_default_op)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, op");
    {
	int	op = (int)SvIV(ST(1))
;
	QueryParser *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::set_default_op() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 36 "./XS/QueryParser.xs"
	THIS->set_default_op(static_cast<Query::op>(op));
#line 3551 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_get_default_op); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_get_default_op)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParser *	THIS;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::get_default_op() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 41 "./XS/QueryParser.xs"
	RETVAL = static_cast<int>(THIS->get_default_op());
#line 3577 "Xapian.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_set_database); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_set_database)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, database");
    {
	Database *	database;
	QueryParser *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Database") )
		database = (Database *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::QueryParser::set_database() -- database is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::set_database() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 49 "./XS/QueryParser.xs"
	THIS->set_database(*database);
#line 3612 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_set_max_wildcard_expansion); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_set_max_wildcard_expansion)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, limit");
    {
	QueryParser *	THIS;
	termcount	limit = (termcount)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::set_max_wildcard_expansion() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 54 "./XS/QueryParser.xs"
#if XAPIAN_AT_LEAST(1,5,0)
	THIS->set_max_expansion(limit,
				Xapian::Query::WILDCARD_LIMIT_ERROR,
				Xapian::QueryParser::FLAG_WILDCARD);
#else
	THIS->set_max_wildcard_expansion(limit);
#endif
#line 3644 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_parse_query); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_parse_query)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, q, flags = QueryParser::FLAG_DEFAULT");
    {
	string	q;
	int	flags;
	QueryParser *	THIS;
	Query *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		q.assign(tmp, len);
	}
;

	if (items < 3)
	    flags = QueryParser::FLAG_DEFAULT;
	else {
	    flags = (int)SvIV(ST(2))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::parse_query() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 67 "./XS/QueryParser.xs"
	try {
	    RETVAL = new Query(THIS->parse_query(q,flags));
	} catch (...) {
	    handle_exception();
	}
#line 3689 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_add_prefix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_add_prefix)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, field, prefix");
    {
	QueryParser *	THIS;
	string	field;
	string	prefix;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::add_prefix() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		field.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		prefix.assign(tmp, len);
	}
;

	THIS->add_prefix(field, prefix);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_add_boolean_prefix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_add_boolean_prefix)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, field, prefix");
    {
	QueryParser *	THIS;
	string	field;
	string	prefix;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::add_boolean_prefix() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		field.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		prefix.assign(tmp, len);
	}
;

	THIS->add_boolean_prefix(field, prefix);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_stoplist_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_stoplist_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParser *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::stoplist_begin() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 84 "./XS/QueryParser.xs"
	RETVAL = new TermIterator(THIS->stoplist_begin());
#line 3798 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_stoplist_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_stoplist_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParser *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::stoplist_end() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 91 "./XS/QueryParser.xs"
	RETVAL = new TermIterator(THIS->stoplist_end());
#line 3829 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_unstem_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_unstem_begin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	string	term;
	QueryParser *	THIS;
	TermIterator *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::unstem_begin() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 99 "./XS/QueryParser.xs"
	RETVAL = new TermIterator(THIS->unstem_begin(term));
#line 3868 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_unstem_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_unstem_end)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	string	term;
	QueryParser *	THIS;
	TermIterator *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::unstem_end() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 107 "./XS/QueryParser.xs"
	RETVAL = new TermIterator(THIS->unstem_end(term));
#line 3907 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_get_corrected_query_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_get_corrected_query_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParser *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::get_corrected_query_string() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 114 "./XS/QueryParser.xs"
    try {
	RETVAL = THIS->get_corrected_query_string();
    } catch (...) {
	handle_exception();
    }
#line 3943 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParser *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::get_description() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParser_add_valuerangeprocessor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_add_valuerangeprocessor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, vrproc");
    {
	QueryParser *	THIS;
	ValueRangeProcessor *	vrproc;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::add_valuerangeprocessor() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		vrproc = (ValueRangeProcessor *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::QueryParser::add_valuerangeprocessor() -- vrproc is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 128 "./XS/QueryParser.xs"
	// Keep a reference to the currently set object.
	XAPIAN_PERL_REF(QueryParser, THIS, vrp, ST(1));
	THIS->add_valuerangeprocessor(vrproc);
#line 4007 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__QueryParser_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParser_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParser *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::QueryParser") )
		THIS = (QueryParser *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParser::DESTROY() -- THIS is not a \"Search::Xapian::QueryParser\" object" );
		XSRETURN_UNDEF;
	}
;
#line 135 "./XS/QueryParser.xs"
	XAPIAN_PERL_DESTROY(QueryParser, THIS);
#line 4031 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/Query.xs' from 'XS/QueryParser.xs' */


XS_EUPXS(XS_Search__Xapian__Query_new0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_new0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Query *	RETVAL;
#line 8 "./XS/Query.xs"
	RETVAL = new Query();
#line 4050 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_new1)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "term");
    {
	string	term;
	Query *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(0), len);
		term.assign(tmp, len);
	}
;
#line 16 "./XS/Query.xs"
	RETVAL = new Query(term);
#line 4080 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_new1weight); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_new1weight)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "term, wqf, pos");
    {
	string	term;
	termcount	wqf = (termcount)SvUV(ST(1))
;
	termpos	pos = (termpos)SvUV(ST(2))
;
	Query *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(0), len);
		term.assign(tmp, len);
	}
;
#line 26 "./XS/Query.xs"
	RETVAL = new Query(term, wqf, pos);
#line 4114 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_new3scale); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_new3scale)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "op, query, factor");
    {
	Query *	RETVAL;
	int	op = (int)SvIV(ST(0))
;
	Query *	query;
	double	factor = (double)SvNV(ST(2))
;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Query") )
		query = (Query *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Query::new3scale() -- query is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;
#line 33 "./XS/Query.xs"
	RETVAL = new Query( (Query::op) op, *query, factor );
#line 4149 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_new3range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_new3range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "op, valno, limit");
    {
	int	op = (int)SvIV(ST(0))
;
	valueno	valno = (valueno)SvUV(ST(1))
;
	string	limit;
	Query *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		limit.assign(tmp, len);
	}
;
#line 43 "./XS/Query.xs"
	RETVAL = new Query( (Query::op) op, valno, limit );
#line 4183 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_new4range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_new4range)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "op, valno, start, end");
    {
	int	op = (int)SvIV(ST(0))
;
	valueno	valno = (valueno)SvUV(ST(1))
;
	string	start;
	string	end;
	Query *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		start.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(3), len);
		end.assign(tmp, len);
	}
;
#line 54 "./XS/Query.xs"
	RETVAL = new Query( (Query::op) op, valno, start, end );
#line 4225 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_newN); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_newN)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "op_, ...");
    {
	Query *	RETVAL;
	int	op_ = (int)SvIV(ST(0))
;
#line 61 "./XS/Query.xs"
	Query::op op = (Query::op)op_;
	try {
	    vector<Query> queries;
	    queries.reserve(items - 1);
	    for( int i = 1; i < items; i++ ) {
		SV *sv = ST (i);
		if (sv_isa(sv, "Search::Xapian::Query")) {
		    Query *query = (Query*) SvIV((SV*) SvRV(sv));
		    queries.push_back(*query);
		} else if ( SvOK(sv) ) {
		    STRLEN len;
		    const char * ptr = SvPV(sv, len);
		    queries.push_back(Query(string(ptr, len)));
		} else {
		    croak( "USAGE: Search::Xapian::Query->new(OP, @TERMS_OR_QUERY_OBJECTS)" );
		}
	    }
	    RETVAL = new Query(op, queries.begin(), queries.end());
	} catch (...) {
	    handle_exception();
	}
#line 4269 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_get_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_get_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Query *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Query") )
		THIS = (Query *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Query::get_length() -- THIS is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_length();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_get_terms_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_get_terms_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Query *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Query") )
		THIS = (Query *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Query::get_terms_begin() -- THIS is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;
#line 91 "./XS/Query.xs"
	RETVAL = new TermIterator(THIS->get_terms_begin());
#line 4327 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_get_terms_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_get_terms_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Query *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Query") )
		THIS = (Query *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Query::get_terms_end() -- THIS is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;
#line 98 "./XS/Query.xs"
	RETVAL = new TermIterator(THIS->get_terms_end());
#line 4358 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_empty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_empty)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Query *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Query") )
		THIS = (Query *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Query::empty() -- THIS is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->empty();
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Query *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Query") )
		THIS = (Query *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Query::get_description() -- THIS is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Query_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Query_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Query *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Query") )
		THIS = (Query *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Query::DESTROY() -- THIS is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/MultiValueSorter.xs' from 'XS/Query.xs' */


XS_EUPXS(XS_Search__Xapian__MultiValueSorter_new0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MultiValueSorter_new0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	MultiValueKeyMaker *	RETVAL;
#line 8 "./XS/MultiValueSorter.xs"
	RETVAL = new MultiValueKeyMaker();
#line 4458 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MultiValueSorter", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MultiValueSorter_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MultiValueSorter_add)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, valno, forward= NO_INIT");
    {
	MultiValueKeyMaker *	THIS;
	valueno	valno = (valueno)SvUV(ST(1))
;
	bool	forward;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MultiValueSorter") )
		THIS = (MultiValueKeyMaker *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MultiValueSorter::add() -- THIS is not a \"Search::Xapian::MultiValueSorter\" object" );
		XSRETURN_UNDEF;
	}
;

	if (items >= 3) {
	    forward = (bool)SvTRUE(ST(2))
;
	}
#line 15 "./XS/MultiValueSorter.xs"
	if (items == 3) { /* items includes the hidden this pointer */
	    THIS->add_value(valno, !forward);
	} else {
	    THIS->add_value(valno);
	}
#line 4500 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MultiValueSorter_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MultiValueSorter_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MultiValueKeyMaker *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MultiValueSorter") )
		THIS = (MultiValueKeyMaker *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MultiValueSorter::DESTROY() -- THIS is not a \"Search::Xapian::MultiValueSorter\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/RSet.xs' from 'XS/MultiValueSorter.xs' */


XS_EUPXS(XS_Search__Xapian__RSet_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	RSet *	RETVAL;
#line 8 "./XS/RSet.xs"
	RETVAL = new RSet();
#line 4542 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::RSet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RSet_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	RSet *	other;
	RSet *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		other = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::new2() -- other is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/RSet.xs"
	RETVAL = new RSet(*other);
#line 4573 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::RSet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RSet_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RSet *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::size() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->size();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RSet_empty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_empty)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RSet *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::empty() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->empty();
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RSet_add_document1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_add_document1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, it");
    {
	MSetIterator *	it;
	RSet *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		it = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::RSet::add_document1() -- it is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::add_document1() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 31 "./XS/RSet.xs"
	THIS->add_document(*it);
#line 4664 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__RSet_add_document2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_add_document2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	docid	did = (docid)SvUV(ST(1))
;
	RSet *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::add_document2() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 37 "./XS/RSet.xs"
	THIS->add_document(did);
#line 4690 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__RSet_remove_document1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_remove_document1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, it");
    {
	MSetIterator *	it;
	RSet *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		it = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::RSet::remove_document1() -- it is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::remove_document1() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 43 "./XS/RSet.xs"
	THIS->remove_document(*it);
#line 4723 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__RSet_remove_document2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_remove_document2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	docid	did = (docid)SvUV(ST(1))
;
	RSet *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::remove_document2() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 49 "./XS/RSet.xs"
	THIS->remove_document(did);
#line 4749 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__RSet_contains1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_contains1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, it");
    {
	MSetIterator *	it;
	RSet *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		it = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::RSet::contains1() -- it is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::contains1() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 55 "./XS/RSet.xs"
	RETVAL = THIS->contains(*it);
#line 4783 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RSet_contains2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_contains2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	docid	did = (docid)SvUV(ST(1))
;
	RSet *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::contains2() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 63 "./XS/RSet.xs"
	RETVAL = THIS->contains(did);
#line 4811 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RSet_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RSet *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::get_description() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RSet_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RSet_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RSet *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::RSet") )
		THIS = (RSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RSet::DESTROY() -- THIS is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/ESetIterator.xs' from 'XS/RSet.xs' */


XS_EUPXS(XS_Search__Xapian__ESetIterator_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	ESetIterator *	RETVAL;
#line 8 "./XS/ESetIterator.xs"
	RETVAL = new ESetIterator();
#line 4881 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	ESetIterator *	other;
	ESetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		other = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::new2() -- other is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/ESetIterator.xs"
	RETVAL = new ESetIterator(* other);
#line 4912 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_inc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESetIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::inc() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 23 "./XS/ESetIterator.xs"
	++(*THIS);
#line 4942 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_dec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESetIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::dec() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 28 "./XS/ESetIterator.xs"
	--(*THIS);
#line 4966 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_equal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	ESetIterator *	THIS;
	bool	RETVAL;
	ESetIterator *	that;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::equal() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::ESetIterator") )
		that = (ESetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::ESetIterator::equal() -- that is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 33 "./XS/ESetIterator.xs"
	RETVAL = ((*THIS) == (*that));
#line 5000 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_nequal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_nequal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	ESetIterator *	THIS;
	bool	RETVAL;
	ESetIterator *	that;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::nequal() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::ESetIterator") )
		that = (ESetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::ESetIterator::nequal() -- that is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 40 "./XS/ESetIterator.xs"
	RETVAL = ((*THIS) != (*that));
#line 5035 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_get_termname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_get_termname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESetIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::get_termname() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 47 "./XS/ESetIterator.xs"
	RETVAL = THIS->operator*();
#line 5062 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_get_weight); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_get_weight)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESetIterator *	THIS;
	double	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::get_weight() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_weight();
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESetIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::get_description() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESetIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESetIterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESetIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESetIterator") )
		THIS = (ESetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESetIterator::DESTROY() -- THIS is not a \"Search::Xapian::ESetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/Error.xs' from 'XS/ESetIterator.xs' */


XS_EUPXS(XS_Search__Xapian__Error_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Error_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Error *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Error *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Error::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Error_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Error_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Error *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Error *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Error::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Error_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Error_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Error *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Error *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Error::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Error_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Error_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Error *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Error *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Error::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Error_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Error_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Error *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Error *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Error::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'XS/LogicError.xs' from 'XS/Error.xs' */


/* INCLUDE:  Including 'XS/RuntimeError.xs' from 'XS/LogicError.xs' */


XS_EUPXS(XS_Search__Xapian__RuntimeError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RuntimeError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RuntimeError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RuntimeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RuntimeError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RuntimeError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RuntimeError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RuntimeError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RuntimeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RuntimeError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RuntimeError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RuntimeError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RuntimeError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RuntimeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RuntimeError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RuntimeError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RuntimeError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RuntimeError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RuntimeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RuntimeError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RuntimeError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RuntimeError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RuntimeError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RuntimeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RuntimeError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'XS/DatabaseError.xs' from 'XS/RuntimeError.xs' */


/* INCLUDE:  Including 'XS/DocNotFoundError.xs' from 'XS/DatabaseError.xs' */


/* INCLUDE:  Including 'XS/FeatureUnavailableError.xs' from 'XS/DocNotFoundError.xs' */


/* INCLUDE:  Including 'XS/InternalError.xs' from 'XS/FeatureUnavailableError.xs' */


/* INCLUDE:  Including 'XS/NetworkError.xs' from 'XS/InternalError.xs' */


/* INCLUDE:  Including 'XS/QueryParserError.xs' from 'XS/NetworkError.xs' */


/* INCLUDE:  Including 'XS/SerialisationError.xs' from 'XS/QueryParserError.xs' */


/* INCLUDE:  Including 'XS/RangeError.xs' from 'XS/SerialisationError.xs' */


/* INCLUDE:  Including 'XS/WildcardError.xs' from 'XS/RangeError.xs' */


XS_EUPXS(XS_Search__Xapian__WildcardError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WildcardError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WildcardError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WildcardError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WildcardError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WildcardError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WildcardError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WildcardError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WildcardError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WildcardError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WildcardError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WildcardError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WildcardError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WildcardError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WildcardError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WildcardError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WildcardError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WildcardError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WildcardError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WildcardError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__WildcardError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__WildcardError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	WildcardError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (WildcardError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::WildcardError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/RangeError.xs' from 'XS/WildcardError.xs' */


XS_EUPXS(XS_Search__Xapian__RangeError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RangeError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RangeError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RangeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RangeError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RangeError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RangeError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RangeError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RangeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RangeError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RangeError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RangeError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RangeError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RangeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RangeError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RangeError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RangeError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RangeError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RangeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RangeError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__RangeError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__RangeError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	RangeError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (RangeError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::RangeError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/SerialisationError.xs' from 'XS/RangeError.xs' */


XS_EUPXS(XS_Search__Xapian__SerialisationError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SerialisationError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	SerialisationError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (SerialisationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SerialisationError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__SerialisationError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SerialisationError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	SerialisationError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (SerialisationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SerialisationError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__SerialisationError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SerialisationError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	SerialisationError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (SerialisationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SerialisationError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__SerialisationError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SerialisationError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	SerialisationError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (SerialisationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SerialisationError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__SerialisationError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__SerialisationError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	SerialisationError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (SerialisationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::SerialisationError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/QueryParserError.xs' from 'XS/SerialisationError.xs' */


XS_EUPXS(XS_Search__Xapian__QueryParserError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParserError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParserError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (QueryParserError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParserError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParserError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParserError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParserError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (QueryParserError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParserError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParserError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParserError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParserError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (QueryParserError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParserError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParserError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParserError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParserError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (QueryParserError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParserError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__QueryParserError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__QueryParserError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	QueryParserError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (QueryParserError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::QueryParserError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/NetworkError.xs' from 'XS/QueryParserError.xs' */


XS_EUPXS(XS_Search__Xapian__NetworkError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'XS/NetworkTimeoutError.xs' from 'XS/NetworkError.xs' */


XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkTimeoutError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkTimeoutError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkTimeoutError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkTimeoutError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkTimeoutError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkTimeoutError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkTimeoutError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkTimeoutError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkTimeoutError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkTimeoutError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkTimeoutError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkTimeoutError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NetworkTimeoutError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NetworkTimeoutError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NetworkTimeoutError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NetworkTimeoutError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/NetworkError.xs' from 'XS/NetworkTimeoutError.xs' */


/* INCLUDE: Returning to 'XS/InternalError.xs' from 'XS/NetworkError.xs' */


XS_EUPXS(XS_Search__Xapian__InternalError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InternalError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InternalError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InternalError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InternalError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InternalError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InternalError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InternalError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InternalError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InternalError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InternalError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InternalError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InternalError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InternalError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InternalError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InternalError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InternalError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InternalError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InternalError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InternalError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InternalError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InternalError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InternalError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InternalError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InternalError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/FeatureUnavailableError.xs' from 'XS/InternalError.xs' */


XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	FeatureUnavailableError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (FeatureUnavailableError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::FeatureUnavailableError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	FeatureUnavailableError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (FeatureUnavailableError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::FeatureUnavailableError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	FeatureUnavailableError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (FeatureUnavailableError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::FeatureUnavailableError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	FeatureUnavailableError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (FeatureUnavailableError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::FeatureUnavailableError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__FeatureUnavailableError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	FeatureUnavailableError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (FeatureUnavailableError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::FeatureUnavailableError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DocNotFoundError.xs' from 'XS/FeatureUnavailableError.xs' */


XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DocNotFoundError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DocNotFoundError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DocNotFoundError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DocNotFoundError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DocNotFoundError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DocNotFoundError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DocNotFoundError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DocNotFoundError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DocNotFoundError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DocNotFoundError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DocNotFoundError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DocNotFoundError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DocNotFoundError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DocNotFoundError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DocNotFoundError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DocNotFoundError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DocNotFoundError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DocNotFoundError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DatabaseError.xs' from 'XS/DocNotFoundError.xs' */


XS_EUPXS(XS_Search__Xapian__DatabaseError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'XS/DatabaseCorruptError.xs' from 'XS/DatabaseError.xs' */


/* INCLUDE:  Including 'XS/DatabaseCreateError.xs' from 'XS/DatabaseCorruptError.xs' */


/* INCLUDE:  Including 'XS/DatabaseLockError.xs' from 'XS/DatabaseCreateError.xs' */


/* INCLUDE:  Including 'XS/DatabaseModifiedError.xs' from 'XS/DatabaseLockError.xs' */


/* INCLUDE:  Including 'XS/DatabaseOpeningError.xs' from 'XS/DatabaseModifiedError.xs' */


XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseOpeningError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseOpeningError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseOpeningError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseOpeningError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseOpeningError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseOpeningError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseOpeningError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseOpeningError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseOpeningError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseOpeningError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseOpeningError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseOpeningError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseOpeningError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseOpeningError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseOpeningError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseOpeningError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'XS/DatabaseVersionError.xs' from 'XS/DatabaseOpeningError.xs' */


XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseVersionError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseVersionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseVersionError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseVersionError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseVersionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseVersionError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseVersionError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseVersionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseVersionError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseVersionError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseVersionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseVersionError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseVersionError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseVersionError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseVersionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseVersionError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DatabaseOpeningError.xs' from 'XS/DatabaseVersionError.xs' */


/* INCLUDE: Returning to 'XS/DatabaseModifiedError.xs' from 'XS/DatabaseOpeningError.xs' */


XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseModifiedError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseModifiedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseModifiedError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseModifiedError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseModifiedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseModifiedError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseModifiedError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseModifiedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseModifiedError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseModifiedError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseModifiedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseModifiedError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseModifiedError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseModifiedError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseModifiedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseModifiedError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DatabaseLockError.xs' from 'XS/DatabaseModifiedError.xs' */


XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseLockError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseLockError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseLockError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseLockError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseLockError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseLockError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseLockError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseLockError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseLockError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseLockError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseLockError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseLockError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseLockError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseLockError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseLockError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseLockError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseLockError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseLockError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DatabaseCreateError.xs' from 'XS/DatabaseLockError.xs' */


XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCreateError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCreateError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCreateError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCreateError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCreateError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCreateError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCreateError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCreateError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCreateError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCreateError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCreateError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCreateError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCreateError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCreateError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCreateError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCreateError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DatabaseCorruptError.xs' from 'XS/DatabaseCreateError.xs' */


XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCorruptError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCorruptError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCorruptError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCorruptError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCorruptError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCorruptError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCorruptError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCorruptError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCorruptError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCorruptError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCorruptError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCorruptError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DatabaseCorruptError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DatabaseCorruptError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DatabaseCorruptError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DatabaseCorruptError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DatabaseError.xs' from 'XS/DatabaseCorruptError.xs' */


/* INCLUDE: Returning to 'XS/RuntimeError.xs' from 'XS/DatabaseError.xs' */


/* INCLUDE: Returning to 'XS/LogicError.xs' from 'XS/RuntimeError.xs' */


XS_EUPXS(XS_Search__Xapian__LogicError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__LogicError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LogicError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LogicError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::LogicError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__LogicError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__LogicError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LogicError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LogicError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::LogicError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__LogicError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__LogicError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LogicError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LogicError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::LogicError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__LogicError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__LogicError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LogicError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LogicError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::LogicError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__LogicError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__LogicError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	LogicError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (LogicError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::LogicError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'XS/AssertionError.xs' from 'XS/LogicError.xs' */


/* INCLUDE:  Including 'XS/InvalidArgumentError.xs' from 'XS/AssertionError.xs' */


/* INCLUDE:  Including 'XS/InvalidOperationError.xs' from 'XS/InvalidArgumentError.xs' */


/* INCLUDE:  Including 'XS/UnimplementedError.xs' from 'XS/InvalidOperationError.xs' */


XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	UnimplementedError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (UnimplementedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::UnimplementedError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	UnimplementedError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (UnimplementedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::UnimplementedError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	UnimplementedError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (UnimplementedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::UnimplementedError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__UnimplementedError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	UnimplementedError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (UnimplementedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::UnimplementedError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__UnimplementedError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__UnimplementedError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	UnimplementedError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (UnimplementedError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::UnimplementedError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/InvalidOperationError.xs' from 'XS/UnimplementedError.xs' */


XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidOperationError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidOperationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidOperationError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidOperationError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidOperationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidOperationError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidOperationError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidOperationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidOperationError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidOperationError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidOperationError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidOperationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidOperationError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidOperationError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidOperationError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidOperationError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidOperationError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidOperationError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/InvalidArgumentError.xs' from 'XS/InvalidOperationError.xs' */


XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidArgumentError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidArgumentError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidArgumentError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidArgumentError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidArgumentError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidArgumentError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidArgumentError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidArgumentError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidArgumentError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidArgumentError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidArgumentError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidArgumentError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__InvalidArgumentError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	InvalidArgumentError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (InvalidArgumentError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::InvalidArgumentError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/AssertionError.xs' from 'XS/InvalidArgumentError.xs' */


XS_EUPXS(XS_Search__Xapian__AssertionError_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__AssertionError_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	AssertionError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (AssertionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::AssertionError::get_type() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_type();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__AssertionError_get_msg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__AssertionError_get_msg)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	AssertionError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (AssertionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::AssertionError::get_msg() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_msg();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__AssertionError_get_context); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__AssertionError_get_context)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	AssertionError *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (AssertionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::AssertionError::get_context() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_context();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__AssertionError_get_error_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__AssertionError_get_error_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	AssertionError *	THIS;
	const char *	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (AssertionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::AssertionError::get_error_string() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_error_string();
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__AssertionError_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__AssertionError_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	AssertionError *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (AssertionError *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::AssertionError::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/LogicError.xs' from 'XS/AssertionError.xs' */


/* INCLUDE: Returning to 'XS/Error.xs' from 'XS/LogicError.xs' */


/* INCLUDE: Returning to 'XS/ESet.xs' from 'XS/Error.xs' */


XS_EUPXS(XS_Search__Xapian__ESet_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	ESet *	RETVAL;
#line 8 "./XS/ESet.xs"
	RETVAL = new ESet();
#line 8331 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	ESet *	other;
	ESet *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		other = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::new2() -- other is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/ESet.xs"
	RETVAL = new ESet(*other);
#line 8362 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_get_ebound); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_get_ebound)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::get_ebound() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_ebound();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_size)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::size() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->size();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_empty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_empty)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::empty() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->empty();
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;
	ESetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::begin() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 35 "./XS/ESet.xs"
	RETVAL = new ESetIterator(THIS->begin());
#line 8473 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;
	ESetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::end() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 42 "./XS/ESet.xs"
	RETVAL = new ESetIterator(THIS->end());
#line 8504 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_back); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_back)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;
	ESetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::back() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 49 "./XS/ESet.xs"
	RETVAL = new ESetIterator(THIS->back());
#line 8535 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, i");
    {
	ESet *	THIS;
	ESetIterator *	RETVAL;
	doccount	i = (doccount)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::FETCH() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 56 "./XS/ESet.xs"
	RETVAL = new ESetIterator((*THIS)[i]);
#line 8568 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::get_description() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ESet_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ESet_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ESet *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::ESet") )
		THIS = (ESet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ESet::DESTROY() -- THIS is not a \"Search::Xapian::ESet\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/MSetIterator.xs' from 'XS/ESet.xs' */


XS_EUPXS(XS_Search__Xapian__MSetIterator_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	MSetIterator *	RETVAL;
#line 8 "./XS/MSetIterator.xs"
	RETVAL = new MSetIterator();
#line 8643 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	MSetIterator *	other;
	MSetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		other = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::new2() -- other is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/MSetIterator.xs"
	RETVAL = new MSetIterator(* other);
#line 8674 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_inc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::inc() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 23 "./XS/MSetIterator.xs"
	++(*THIS);
#line 8704 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_dec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::dec() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 28 "./XS/MSetIterator.xs"
	--(*THIS);
#line 8728 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_equal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	MSetIterator *	that;
	MSetIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		that = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::MSetIterator::equal() -- that is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::equal() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 34 "./XS/MSetIterator.xs"
	RETVAL = ((*THIS) == (*that));
#line 8762 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_nequal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_nequal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, that");
    {
	MSetIterator *	that;
	MSetIterator *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		that = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::MSetIterator::nequal() -- that is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::nequal() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 42 "./XS/MSetIterator.xs"
	RETVAL = ((*THIS) != (*that));
#line 8797 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_get_docid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_get_docid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;
	docid	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::get_docid() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 49 "./XS/MSetIterator.xs"
	RETVAL = THIS->operator*();
#line 8824 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_get_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_get_document)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;
	Document *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::get_document() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;
#line 56 "./XS/MSetIterator.xs"
	RETVAL = new Document(THIS->get_document());
#line 8851 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Document", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_get_rank); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_get_rank)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::get_rank() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_rank();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_get_weight); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_get_weight)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;
	double	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::get_weight() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_weight();
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_get_collapse_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_get_collapse_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::get_collapse_count() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_collapse_count();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_get_percent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_get_percent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::get_percent() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_percent();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::get_description() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSetIterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSetIterator_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSetIterator *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSetIterator") )
		THIS = (MSetIterator *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSetIterator::DESTROY() -- THIS is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/MSet.xs' from 'XS/MSetIterator.xs' */


XS_EUPXS(XS_Search__Xapian__MSet_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	MSet *	RETVAL;
#line 8 "./XS/MSet.xs"
	RETVAL = new MSet();
#line 9034 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	MSet *	other;
	MSet *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		other = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::new2() -- other is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/MSet.xs"
	RETVAL = new MSet(*other);
#line 9065 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_fetch1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_fetch1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, begin, end");
    {
	MSetIterator *	begin;
	MSetIterator *	end;
	MSet *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		begin = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::MSet::fetch1() -- begin is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(2)) && sv_derived_from(ST(2), "Search::Xapian::MSetIterator") )
		end = (MSetIterator *)SvIV((SV*)SvRV( ST(2) ));
	else{
		warn( "Search::Xapian::MSet::fetch1() -- end is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::fetch1() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 25 "./XS/MSet.xs"
	THIS->fetch(*begin, *end);
#line 9113 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MSet_fetch2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_fetch2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, item");
    {
	MSetIterator *	item;
	MSet *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		item = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::MSet::fetch2() -- item is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::fetch2() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 31 "./XS/MSet.xs"
	THIS->fetch(*item);
#line 9146 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MSet_fetch3); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_fetch3)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::fetch3() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 36 "./XS/MSet.xs"
	THIS->fetch();
#line 9170 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MSet_convert_to_percent1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_convert_to_percent1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, wt");
    {
	double	wt = (double)SvNV(ST(1))
;
	MSet *	THIS;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::convert_to_percent1() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 42 "./XS/MSet.xs"
	RETVAL = THIS->convert_to_percent(wt);
#line 9198 "Xapian.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_convert_to_percent2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_convert_to_percent2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, it");
    {
	MSetIterator *	it;
	MSet *	THIS;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		it = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::MSet::convert_to_percent2() -- it is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::convert_to_percent2() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 50 "./XS/MSet.xs"
	RETVAL = THIS->convert_to_percent(*it);
#line 9235 "Xapian.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_termfreq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_termfreq)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	string	tname;
	MSet *	THIS;
	doccount	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_termfreq() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 58 "./XS/MSet.xs"
	RETVAL = THIS->get_termfreq(tname);
#line 9271 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_termweight); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_termweight)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	string	tname;
	MSet *	THIS;
	double	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_termweight() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 66 "./XS/MSet.xs"
	RETVAL = THIS->get_termweight(tname);
#line 9307 "Xapian.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_firstitem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_firstitem)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_firstitem() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_firstitem();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_matches_lower_bound); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_matches_lower_bound)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_matches_lower_bound() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_matches_lower_bound();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_matches_estimated); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_matches_estimated)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_matches_estimated() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_matches_estimated();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_matches_upper_bound); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_matches_upper_bound)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_matches_upper_bound() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_matches_upper_bound();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_max_possible); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_max_possible)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	double	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_max_possible() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_max_possible();
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_max_attained); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_max_attained)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	double	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_max_attained() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_max_attained();
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_size)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::size() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->size();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_empty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_empty)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	bool	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::empty() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->empty();
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_swap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_swap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, other");
    {
	MSet *	other;
	MSet *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSet") )
		other = (MSet *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::MSet::swap() -- other is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::swap() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 100 "./XS/MSet.xs"
	THIS->swap(*other);
#line 9557 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MSet_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	MSetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::begin() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 105 "./XS/MSet.xs"
	RETVAL = new MSetIterator(THIS->begin());
#line 9582 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	MSetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::end() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 112 "./XS/MSet.xs"
	RETVAL = new MSetIterator(THIS->end());
#line 9613 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_back); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_back)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	MSetIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::back() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 119 "./XS/MSet.xs"
	RETVAL = new MSetIterator(THIS->back());
#line 9644 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_FETCH)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, i");
    {
	MSet *	THIS;
	MSetIterator *	RETVAL;
	doccount	i = (doccount)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::FETCH() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;
#line 129 "./XS/MSet.xs"
	RETVAL = new MSetIterator((*THIS)[i]);
#line 9678 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSetIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::get_description() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MSet_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MSet_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MSet *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MSet") )
		THIS = (MSet *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MSet::DESTROY() -- THIS is not a \"Search::Xapian::MSet\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/Enquire.xs' from 'XS/MSet.xs' */


XS_EUPXS(XS_Search__Xapian__Enquire_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, databases");
    {
	Database *	databases;
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	Enquire *	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Database") )
		databases = (Database *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::new() -- databases is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 9 "./XS/Enquire.xs"
	try {
	    RETVAL = XAPIAN_PERL_NEW(Enquire, (*databases));
	} catch (...) {
	    handle_exception();
	}
#line 9768 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_query1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_query1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, query");
    {
	Query *	query;
	Enquire *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Query") )
		query = (Query *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::set_query1() -- query is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_query1() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 21 "./XS/Enquire.xs"
	try {
	    THIS->set_query(*query);
	} catch (...) {
	    handle_exception();
	}
#line 9811 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_query2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_query2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, query, len");
    {
	Query *	query;
	termcount	len = (termcount)SvUV(ST(2))
;
	Enquire *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Query") )
		query = (Query *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::set_query2() -- query is not a \"Search::Xapian::Query\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_query2() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 32 "./XS/Enquire.xs"
	try {
	    THIS->set_query(*query, len);
	} catch (...) {
	    handle_exception();
	}
#line 9850 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_query); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_query)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Enquire *	THIS;
	Query *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_query() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 41 "./XS/Enquire.xs"
	try {
	    RETVAL = new Query(THIS->get_query());
	} catch (...) {
	    handle_exception();
	}
#line 9879 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Query", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_collapse_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_collapse_key)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, collapse_key, collapse_max = 1");
    {
	valueno	collapse_key = (valueno)SvUV(ST(1))
;
	doccount	collapse_max;
	Enquire *	THIS;

	if (items < 3)
	    collapse_max = 1;
	else {
	    collapse_max = (doccount)SvUV(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_collapse_key() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 54 "./XS/Enquire.xs"
	try {
	    THIS->set_collapse_key(collapse_key, collapse_max);
	} catch (...) {
	    handle_exception();
	}
#line 9923 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_docid_order); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_docid_order)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, order");
    {
	int	order = (int)SvIV(ST(1))
;
	Enquire *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_docid_order() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 64 "./XS/Enquire.xs"
	try {
	    THIS->set_docid_order(static_cast<Enquire::docid_order>(order));
	} catch (...) {
	    handle_exception();
	}
#line 9953 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_cutoff); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_cutoff)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, percent_cutoff, weight_cutoff = NO_INIT");
    {
	int	percent_cutoff = (int)SvIV(ST(1))
;
	double	weight_cutoff;
	Enquire *	THIS;

	if (items >= 3) {
	    weight_cutoff = (double)SvNV(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_cutoff() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 75 "./XS/Enquire.xs"
	try {
	    if (items == 3) { /* items includes the hidden this pointer */
		THIS->set_cutoff(percent_cutoff, weight_cutoff);
	    } else {
		THIS->set_cutoff(percent_cutoff);
	    }
	} catch (...) {
	    handle_exception();
	}
#line 9993 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_relevance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_relevance)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Enquire *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_relevance() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 88 "./XS/Enquire.xs"
	// Clear reference to any currently set sorter object.
	XAPIAN_PERL_REF(Enquire, THIS, sorter, NULL);
	THIS->set_sort_by_relevance();
#line 10019 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_value)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, sort_key, ascending = true");
    {
	valueno	sort_key = (valueno)SvUV(ST(1))
;
	bool	ascending;
	Enquire *	THIS;

	if (items < 3)
	    ascending = true;
	else {
	    ascending = (bool)SvTRUE(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_value() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 97 "./XS/Enquire.xs"
	// Clear reference to any currently set sorter object.
	XAPIAN_PERL_REF(Enquire, THIS, sorter, NULL);
	try {
	    THIS->set_sort_by_value(sort_key, ascending);
	} catch (...) {
	    handle_exception();
	}
#line 10059 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_value_then_relevance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_value_then_relevance)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, sort_key, ascending = true");
    {
	valueno	sort_key = (valueno)SvUV(ST(1))
;
	bool	ascending;
	Enquire *	THIS;

	if (items < 3)
	    ascending = true;
	else {
	    ascending = (bool)SvTRUE(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_value_then_relevance() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 110 "./XS/Enquire.xs"
	// Clear reference to any currently set sorter object.
	XAPIAN_PERL_REF(Enquire, THIS, sorter, NULL);
	try {
	    THIS->set_sort_by_value_then_relevance(sort_key, ascending);
	} catch (...) {
	    handle_exception();
	}
#line 10099 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_relevance_then_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_relevance_then_value)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, sort_key, ascending = true");
    {
	valueno	sort_key = (valueno)SvUV(ST(1))
;
	bool	ascending;
	Enquire *	THIS;

	if (items < 3)
	    ascending = true;
	else {
	    ascending = (bool)SvTRUE(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_relevance_then_value() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 123 "./XS/Enquire.xs"
	// Clear reference to any currently set sorter object.
	XAPIAN_PERL_REF(Enquire, THIS, sorter, NULL);
	try {
	    THIS->set_sort_by_relevance_then_value(sort_key, ascending);
	} catch (...) {
	    handle_exception();
	}
#line 10139 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_key)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, sorter, ascending = true");
    {
	MultiValueKeyMaker *	sorter;
	bool	ascending;
	Enquire *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MultiValueSorter") )
		sorter = (MultiValueKeyMaker *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_key() -- sorter is not a \"Search::Xapian::MultiValueSorter\" object" );
		XSRETURN_UNDEF;
	}
;

	if (items < 3)
	    ascending = true;
	else {
	    ascending = (bool)SvTRUE(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_key() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 136 "./XS/Enquire.xs"
	// Keep a reference to the currently set object.
	XAPIAN_PERL_REF(Enquire, THIS, sorter, ST(1));
	try {
	    THIS->set_sort_by_key(sorter, ascending);
	} catch (...) {
	    handle_exception();
	}
#line 10186 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_key_then_relevance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_key_then_relevance)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, sorter, ascending = true");
    {
	MultiValueKeyMaker *	sorter;
	bool	ascending;
	Enquire *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MultiValueSorter") )
		sorter = (MultiValueKeyMaker *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_key_then_relevance() -- sorter is not a \"Search::Xapian::MultiValueSorter\" object" );
		XSRETURN_UNDEF;
	}
;

	if (items < 3)
	    ascending = true;
	else {
	    ascending = (bool)SvTRUE(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_key_then_relevance() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 149 "./XS/Enquire.xs"
	// Keep a reference to the currently set object.
	XAPIAN_PERL_REF(Enquire, THIS, sorter, ST(1));
	try {
	    THIS->set_sort_by_key_then_relevance(sorter, ascending);
	} catch (...) {
	    handle_exception();
	}
#line 10233 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_relevance_then_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_sort_by_relevance_then_key)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, sorter, ascending = true");
    {
	MultiValueKeyMaker *	sorter;
	bool	ascending;
	Enquire *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MultiValueSorter") )
		sorter = (MultiValueKeyMaker *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_relevance_then_key() -- sorter is not a \"Search::Xapian::MultiValueSorter\" object" );
		XSRETURN_UNDEF;
	}
;

	if (items < 3)
	    ascending = true;
	else {
	    ascending = (bool)SvTRUE(ST(2))
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_sort_by_relevance_then_key() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 162 "./XS/Enquire.xs"
	// Keep a reference to the currently set object.
	XAPIAN_PERL_REF(Enquire, THIS, sorter, ST(1));
	try {
	    THIS->set_sort_by_relevance_then_key(sorter, ascending);
	} catch (...) {
	    handle_exception();
	}
#line 10280 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_mset1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_mset1)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 6)
       croak_xs_usage(cv,  "THIS, first, maxitems, checkatleast = NO_INIT, rset = NO_INIT, func = NO_INIT");
    {
	doccount	first = (doccount)SvUV(ST(1))
;
	doccount	maxitems = (doccount)SvUV(ST(2))
;
	doccount	checkatleast;
	RSet *	rset;
	SV *	func;
	Enquire *	THIS;
	MSet *	RETVAL;

	if (items >= 4) {
	    checkatleast = (doccount)SvUV(ST(3))
;
	}

	if (items >= 5) {
	    if( sv_isobject(ST(4)) && sv_derived_from(ST(4), "Search::Xapian::RSet") )
		    rset = (RSet *)SvIV((SV*)SvRV( ST(4) ));
	    else{
		    warn( "Search::Xapian::Enquire::get_mset1() -- rset is not a \"Search::Xapian::RSet\" object" );
		    XSRETURN_UNDEF;
	    }
;
	}

	if (items >= 6) {
	    func = ST(5)
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_mset1() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 178 "./XS/Enquire.xs"
	try {
	    MSet mset;
	    switch (items) { /* items includes the hidden this pointer */
		case 3:
		    mset = THIS->get_mset(first, maxitems);
		    break;
		case 4:
		    mset = THIS->get_mset(first, maxitems, checkatleast);
		    break;
		case 5:
		    mset = THIS->get_mset(first, maxitems, checkatleast, rset);
		    break;
		case 6: {
		    perlMatchDecider d(func);
		    mset = THIS->get_mset(first, maxitems, checkatleast, rset, &d);
		    break;
		}
		default:
		    croak("Bad parameter count for get_mset1");
	    }
	    RETVAL = new MSet(mset);
	} catch (...) {
	    handle_exception();
	}
#line 10355 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_mset2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_mset2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "THIS, first, maxitems, func");
    {
	doccount	first = (doccount)SvUV(ST(1))
;
	doccount	maxitems = (doccount)SvUV(ST(2))
;
	SV *	func = ST(3)
;
	Enquire *	THIS;
	MSet *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_mset2() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 211 "./XS/Enquire.xs"
	try {
	    perlMatchDecider d(func);
	    RETVAL = new MSet(THIS->get_mset(first, maxitems, 0, NULL, &d));
	} catch (...) {
	    handle_exception();
	}
#line 10397 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MSet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_eset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_eset)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "THIS, maxitems, rset, func = NO_INIT");
    {
	doccount	maxitems = (doccount)SvUV(ST(1))
;
	RSet *	rset;
	SV *	func;
	Enquire *	THIS;
	ESet *	RETVAL;

	if( sv_isobject(ST(2)) && sv_derived_from(ST(2), "Search::Xapian::RSet") )
		rset = (RSet *)SvIV((SV*)SvRV( ST(2) ));
	else{
		warn( "Search::Xapian::Enquire::get_eset() -- rset is not a \"Search::Xapian::RSet\" object" );
		XSRETURN_UNDEF;
	}
;

	if (items >= 4) {
	    func = ST(3)
;
	}

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_eset() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 226 "./XS/Enquire.xs"
	try {
	    ESet eset;
	    switch (items) { /* items includes the hidden this pointer */
		case 3:
		    eset = THIS->get_eset(maxitems, *rset);
		    break;
		case 4: {
		    perlExpandDecider d(func);
		    eset = THIS->get_eset(maxitems, *rset, &d);
		    break;
		}
		default:
		    croak("Bad parameter count for get_eset");
	    }
	    RETVAL = new ESet(eset);
	} catch (...) {
	    handle_exception();
	}
#line 10462 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ESet", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_begin1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_begin1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	Enquire *	THIS;
	TermIterator *	RETVAL;
	docid	did = (docid)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_matching_terms_begin1() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 250 "./XS/Enquire.xs"
	try {
	    RETVAL = new TermIterator(THIS->get_matching_terms_begin(did));
	} catch (...) {
	    handle_exception();
	}
#line 10499 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_begin2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_begin2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, it");
    {
	MSetIterator *	it;
	Enquire *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		it = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::get_matching_terms_begin2() -- it is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_matching_terms_begin2() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 262 "./XS/Enquire.xs"
	try {
	    RETVAL = new TermIterator(THIS->get_matching_terms_begin(* it));
	} catch (...) {
	    handle_exception();
	}
#line 10543 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_end1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_end1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	Enquire *	THIS;
	TermIterator *	RETVAL;
	docid	did = (docid)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_matching_terms_end1() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 273 "./XS/Enquire.xs"
	try {
	    RETVAL = new TermIterator(THIS->get_matching_terms_end(did));
	} catch (...) {
	    handle_exception();
	}
#line 10580 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_end2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_matching_terms_end2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, it");
    {
	MSetIterator *	it;
	Enquire *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MSetIterator") )
		it = (MSetIterator *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::get_matching_terms_end2() -- it is not a \"Search::Xapian::MSetIterator\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_matching_terms_end2() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 285 "./XS/Enquire.xs"
	try {
	    RETVAL = new TermIterator(THIS->get_matching_terms_end(* it));
	} catch (...) {
	    handle_exception();
	}
#line 10624 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_set_weighting_scheme); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_set_weighting_scheme)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, weight_");
    {
	Weight *	weight_;
	Enquire *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Weight") )
		weight_ = (Weight *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::set_weighting_scheme() -- weight_ is not a \"Search::Xapian::Weight\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::set_weighting_scheme() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 297 "./XS/Enquire.xs"
	try {
	    THIS->set_weighting_scheme(*weight_);
	} catch (...) {
	    handle_exception();
	}
#line 10667 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Enquire *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::get_description() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Enquire_add_matchspy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_add_matchspy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, spy");
    {
	Enquire *	THIS;
	MatchSpy *	spy;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::add_matchspy() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::MatchSpy") )
		spy = (MatchSpy *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Enquire::add_matchspy() -- spy is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;
#line 309 "./XS/Enquire.xs"
	try {
	    XAPIAN_PERL_REF(Enquire, THIS, matchspy, ST(1));
	    THIS->add_matchspy(spy);
	} catch (...) {
	    handle_exception();
	}
#line 10732 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_clear_matchspies); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_clear_matchspies)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Enquire *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::clear_matchspies() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 319 "./XS/Enquire.xs"
	try {
	    XAPIAN_PERL_REF(Enquire, THIS, clear_matchspies, NULL);
	    THIS->clear_matchspies();
	} catch (...) {
	    handle_exception();
	}
#line 10761 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Enquire_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Enquire_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Enquire *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (Enquire *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Enquire::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 329 "./XS/Enquire.xs"
	XAPIAN_PERL_DESTROY(Enquire, THIS);
#line 10785 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/Document.xs' from 'XS/Enquire.xs' */


XS_EUPXS(XS_Search__Xapian__Document_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Document *	RETVAL;
#line 8 "./XS/Document.xs"
	RETVAL = new Document();
#line 10804 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Document", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "other");
    {
	Document *	other;
	Document *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		other = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::new2() -- other is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 16 "./XS/Document.xs"
	RETVAL = new Document(*other);
#line 10835 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Document", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_get_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_get_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, valno");
    {
	Document *	THIS;
	string	RETVAL;
	dXSTARG;
	valueno	valno = (valueno)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::get_value() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 23 "./XS/Document.xs"
	try {
	    RETVAL = THIS->get_value(valno);
	} catch (...) {
	    handle_exception();
	}
#line 10873 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_add_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_add_value)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, valno, value");
    {
	valueno	valno = (valueno)SvUV(ST(1))
;
	string	value;
	Document *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		value.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::add_value() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 36 "./XS/Document.xs"
	try {
	    THIS->add_value(valno, value);
	} catch (...) {
	    handle_exception();
	}
#line 10913 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_remove_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_remove_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, valno");
    {
	Document *	THIS;
	valueno	valno = (valueno)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::remove_value() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 45 "./XS/Document.xs"
	try {
	    THIS->remove_value(valno);
	} catch (...) {
	    handle_exception();
	}
#line 10943 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_clear_values); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_clear_values)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::clear_values() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;

	THIS->clear_values();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_get_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_get_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::get_data() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 57 "./XS/Document.xs"
	try {
	    RETVAL = THIS->get_data();
	} catch (...) {
	    handle_exception();
	}
#line 10996 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_set_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_set_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, data");
    {
	string	data;
	Document *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		data.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::set_data() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 69 "./XS/Document.xs"
	THIS->set_data(data);
#line 11030 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_add_posting); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_add_posting)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "THIS, tname, tpos, wdfinc = NO_INIT");
    {
	string	tname;
	termpos	tpos = (termpos)SvUV(ST(2))
;
	termcount	wdfinc;
	Document *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if (items >= 4) {
	    wdfinc = (termcount)SvUV(ST(3))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::add_posting() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 77 "./XS/Document.xs"
	try {
	    if (items == 4) { /* items includes the hidden this pointer */
		THIS->add_posting(tname, tpos, wdfinc);
	    } else {
		THIS->add_posting(tname, tpos);
	    }
	} catch (...) {
	    handle_exception();
	}
#line 11078 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_add_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_add_term)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, tname, wdfinc = NO_INIT");
    {
	string	tname;
	termcount	wdfinc;
	Document *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if (items >= 3) {
	    wdfinc = (termcount)SvUV(ST(2))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::add_term() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 92 "./XS/Document.xs"
	try {
	    if (items == 3) { /* items includes the hidden this pointer */
		THIS->add_term(tname, wdfinc);
	    } else {
		THIS->add_term(tname);
	    }
	} catch (...) {
	    handle_exception();
	}
#line 11124 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_add_boolean_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_add_boolean_term)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	string	tname;
	Document *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::add_boolean_term() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 106 "./XS/Document.xs"
	try {
	    THIS->add_boolean_term(tname);
	} catch (...) {
	    handle_exception();
	}
#line 11160 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_remove_posting); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_remove_posting)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "THIS, tname, tpos, wdfdec = NO_INIT");
    {
	string	tname;
	termpos	tpos = (termpos)SvUV(ST(2))
;
	termcount	wdfdec;
	Document *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if (items >= 4) {
	    wdfdec = (termcount)SvUV(ST(3))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::remove_posting() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 118 "./XS/Document.xs"
	try {
	    if (items == 4) { /* items includes the hidden this pointer */
		THIS->remove_posting(tname, tpos, wdfdec);
	    } else {
		THIS->remove_posting(tname, tpos);
	    }
	} catch (...) {
	    handle_exception();
	}
#line 11208 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_remove_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_remove_term)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	string	tname;
	Document *	THIS;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::remove_term() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 132 "./XS/Document.xs"
	try {
	    THIS->remove_term(tname);
	} catch (...) {
	    handle_exception();
	}
#line 11244 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_clear_terms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_clear_terms)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::clear_terms() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;

	THIS->clear_terms();
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Document_termlist_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_termlist_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::termlist_count() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 144 "./XS/Document.xs"
	try {
	    RETVAL = THIS->termlist_count();
	} catch (...) {
	    handle_exception();
	}
#line 11297 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_termlist_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_termlist_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::termlist_begin() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 155 "./XS/Document.xs"
	try {
	    RETVAL = new TermIterator(THIS->termlist_begin());
	} catch (...) {
	    handle_exception();
	}
#line 11328 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_termlist_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_termlist_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::termlist_end() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 166 "./XS/Document.xs"
	RETVAL = new TermIterator(THIS->termlist_end());
#line 11359 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_values_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_values_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	termcount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::values_count() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 173 "./XS/Document.xs"
	try {
	    RETVAL = THIS->values_count();
	} catch (...) {
	    handle_exception();
	}
#line 11395 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_values_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_values_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	ValueIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::values_begin() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 184 "./XS/Document.xs"
	try {
	    RETVAL = new ValueIterator(THIS->values_begin());
	} catch (...) {
	    handle_exception();
	}
#line 11426 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ValueIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_values_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_values_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	ValueIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::values_end() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 195 "./XS/Document.xs"
	RETVAL = new ValueIterator(THIS->values_end());
#line 11457 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::ValueIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_get_docid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_get_docid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	docid	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::get_docid() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;
#line 202 "./XS/Document.xs"
	try {
	    RETVAL = THIS->get_docid();
	} catch (...) {
	    handle_exception();
	}
#line 11493 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::get_description() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Document_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Document_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Document *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Document") )
		THIS = (Document *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Document::DESTROY() -- THIS is not a \"Search::Xapian::Document\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/Database.xs' from 'XS/Document.xs' */


XS_EUPXS(XS_Search__Xapian__Database_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_new1)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "file");
    {
	string	file;
	Database *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(0), len);
		file.assign(tmp, len);
	}
;
#line 9 "./XS/Database.xs"
	try {
	    RETVAL = new Database(file);
	} catch (...) {
	    handle_exception();
	}
#line 11576 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Database", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "database");
    {
	Database *	database;
	Database *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		database = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::new2() -- database is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 21 "./XS/Database.xs"
	try {
	    RETVAL = new Database(*database);
	} catch (...) {
	    handle_exception();
	}
#line 11611 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Database", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_add_database); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_add_database)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, database");
    {
	Database *	database;
	Database *	THIS;

	if( sv_isobject(ST(1)) && sv_derived_from(ST(1), "Search::Xapian::Database") )
		database = (Database *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Search::Xapian::Database::add_database() -- database is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::add_database() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 33 "./XS/Database.xs"
	try {
	    THIS->add_database(*database);
	} catch (...) {
	    handle_exception();
	}
#line 11654 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Database_reopen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_reopen)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::reopen() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 42 "./XS/Database.xs"
	try {
	    THIS->reopen();
	} catch (...) {
	    handle_exception();
	}
#line 11682 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Database_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_description() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 51 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_description();
	} catch (...) {
	    handle_exception();
	}
#line 11712 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_termlist_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_termlist_begin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	docid	did = (docid)SvUV(ST(1))
;
	Database *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::termlist_begin() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 63 "./XS/Database.xs"
	try {
	    RETVAL = new TermIterator(THIS->termlist_begin(did));
	} catch (...) {
	    handle_exception();
	}
#line 11745 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_termlist_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_termlist_end)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	docid	did = (docid)SvUV(ST(1))
;
	Database *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::termlist_end() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 75 "./XS/Database.xs"
	try {
	    RETVAL = new TermIterator(THIS->termlist_end(did));
	} catch (...) {
	    handle_exception();
	}
#line 11782 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_positionlist_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_positionlist_begin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, did, term");
    {
	docid	did = (docid)SvUV(ST(1))
;
	string	term;
	Database *	THIS;
	PositionIterator *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::positionlist_begin() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 88 "./XS/Database.xs"
	try {
	    RETVAL = new PositionIterator(THIS->positionlist_begin(did, term));
	} catch (...) {
	    handle_exception();
	}
#line 11827 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_positionlist_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_positionlist_end)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, did, term");
    {
	docid	did = (docid)SvUV(ST(1))
;
	string	term;
	Database *	THIS;
	PositionIterator *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::positionlist_end() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 101 "./XS/Database.xs"
	try {
	    RETVAL = new PositionIterator(THIS->positionlist_end(did, term));
	} catch (...) {
	    handle_exception();
	}
#line 11872 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PositionIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_allterms_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_allterms_begin)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, prefix = NO_INIT");
    {
	string	prefix;
	Database *	THIS;
	TermIterator *	RETVAL;

	if (items >= 2) {
	    {
		    STRLEN len;
		    const char * tmp = SvPV(ST(1), len);
		    prefix.assign(tmp, len);
	    }
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::allterms_begin() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 113 "./XS/Database.xs"
	try {
	    RETVAL = new TermIterator(THIS->allterms_begin(prefix));
	} catch (...) {
	    handle_exception();
	}
#line 11917 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_allterms_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_allterms_end)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, prefix = NO_INIT");
    {
	string	prefix;
	Database *	THIS;
	TermIterator *	RETVAL;

	if (items >= 2) {
	    {
		    STRLEN len;
		    const char * tmp = SvPV(ST(1), len);
		    prefix.assign(tmp, len);
	    }
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::allterms_end() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 125 "./XS/Database.xs"
	try {
	    RETVAL = new TermIterator(THIS->allterms_end(prefix));
	} catch (...) {
	    handle_exception();
	}
#line 11962 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_postlist_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_postlist_begin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	string	term;
	Database *	THIS;
	PostingIterator *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::postlist_begin() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 137 "./XS/Database.xs"
	try {
	    RETVAL = new PostingIterator(THIS->postlist_begin(term));
	} catch (...) {
	    handle_exception();
	}
#line 12005 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PostingIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_postlist_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_postlist_end)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, term");
    {
	string	term;
	Database *	THIS;
	PostingIterator *	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		term.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::postlist_end() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 149 "./XS/Database.xs"
	try {
	    RETVAL = new PostingIterator(THIS->postlist_end(term));
	} catch (...) {
	    handle_exception();
	}
#line 12048 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::PostingIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_doccount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_doccount)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;
	doccount	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_doccount() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 160 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_doccount();
	} catch (...) {
	    handle_exception();
	}
#line 12084 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_lastdocid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_lastdocid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;
	docid	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_lastdocid() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 171 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_lastdocid();
	} catch (...) {
	    handle_exception();
	}
#line 12116 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_avlength); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_avlength)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;
	doclength	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_avlength() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 182 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_avlength();
	} catch (...) {
	    handle_exception();
	}
#line 12148 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_termfreq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_termfreq)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	string	tname;
	Database *	THIS;
	doccount	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_termfreq() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 194 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_termfreq(tname);
	} catch (...) {
	    handle_exception();
	}
#line 12188 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_term_exists); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_term_exists)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	string	tname;
	Database *	THIS;
	bool	RETVAL;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::term_exists() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 206 "./XS/Database.xs"
	try {
	    RETVAL = THIS->term_exists(tname);
	} catch (...) {
	    handle_exception();
	}
#line 12227 "Xapian.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_collection_freq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_collection_freq)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, tname");
    {
	string	tname;
	Database *	THIS;
	termcount	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		tname.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_collection_freq() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 218 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_collection_freq(tname);
	} catch (...) {
	    handle_exception();
	}
#line 12266 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_doclength); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_doclength)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	docid	did = (docid)SvUV(ST(1))
;
	Database *	THIS;
	doclength	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_doclength() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 230 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_doclength(did);
	} catch (...) {
	    handle_exception();
	}
#line 12300 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_keep_alive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_keep_alive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::keep_alive() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 241 "./XS/Database.xs"
	try {
	    THIS->keep_alive();
	} catch (...) {
	    handle_exception();
	}
#line 12330 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Database_get_document); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_document)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, did");
    {
	Database *	THIS;
	Document *	RETVAL;
	docid	did = (docid)SvUV(ST(1))
;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_document() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 250 "./XS/Database.xs"
	try {
	    RETVAL = new Document(THIS->get_document(did));
	} catch (...) {
	    handle_exception();
	}
#line 12361 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Document", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_spelling_suggestion); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_spelling_suggestion)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "THIS, word, max_edit_distance = 2");
    {
	string	word;
	int	max_edit_distance;
	Database *	THIS;
	string	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		word.assign(tmp, len);
	}
;

	if (items < 3)
	    max_edit_distance = 2;
	else {
	    max_edit_distance = (int)SvIV(ST(2))
;
	}

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_spelling_suggestion() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 263 "./XS/Database.xs"
	try {
	    RETVAL = THIS->get_spelling_suggestion(word, max_edit_distance);
	} catch (...) {
	    handle_exception();
	}
#line 12413 "Xapian.c"
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_get_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_get_metadata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, key");
    {
	Database *	THIS;
	string	RETVAL;
	dXSTARG;
	string	key;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::get_metadata() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		key.assign(tmp, len);
	}
;

	RETVAL = THIS->get_metadata(key);
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__Database_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::close() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;
#line 277 "./XS/Database.xs"
	try {
	    THIS->close();
	} catch (...) {
	    handle_exception();
	}
#line 12478 "Xapian.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__Database_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__Database_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	Database *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Database") )
		THIS = (Database *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::Database::DESTROY() -- THIS is not a \"Search::Xapian::Database\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/BoolWeight.xs' from 'XS/Database.xs' */


XS_EUPXS(XS_Search__Xapian__BoolWeight_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__BoolWeight_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	BoolWeight *	RETVAL;
#line 8 "./XS/BoolWeight.xs"
	try {
	    RETVAL = new BoolWeight();
	} catch (...) {
	    handle_exception();
	}
#line 12524 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Weight", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__BoolWeight_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__BoolWeight_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	BoolWeight *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Weight") )
		THIS = (BoolWeight *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::BoolWeight::DESTROY() -- THIS is not a \"Search::Xapian::Weight\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/BM25Weight.xs' from 'XS/BoolWeight.xs' */


XS_EUPXS(XS_Search__Xapian__BM25Weight_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__BM25Weight_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	BM25Weight *	RETVAL;
#line 8 "./XS/BM25Weight.xs"
	try {
	    RETVAL = new BM25Weight();
	} catch (...) {
	    handle_exception();
	}
#line 12576 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Weight", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__BM25Weight_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__BM25Weight_new2)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "k1, k2, k3, b, min_normlen");
    {
	double	k1 = (double)SvNV(ST(0))
;
	double	k2 = (double)SvNV(ST(1))
;
	double	k3 = (double)SvNV(ST(2))
;
	double	b = (double)SvNV(ST(3))
;
	double	min_normlen = (double)SvNV(ST(4))
;
	BM25Weight *	RETVAL;
#line 24 "./XS/BM25Weight.xs"
	try {
	    RETVAL = new BM25Weight(k1, k2, k3, b, min_normlen);
	} catch (...) {
	    handle_exception();
	}
#line 12612 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::Weight", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__BM25Weight_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__BM25Weight_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	BM25Weight *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::Weight") )
		THIS = (BM25Weight *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::BM25Weight::DESTROY() -- THIS is not a \"Search::Xapian::Weight\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'Xapian.xs' from 'XS/BM25Weight.xs' */


/* INCLUDE:  Including 'XS/DateValueRangeProcessor.xs' from 'Xapian.xs' */


/* INCLUDE:  Including 'XS/NumberValueRangeProcessor.xs' from 'XS/DateValueRangeProcessor.xs' */


/* INCLUDE:  Including 'XS/StringValueRangeProcessor.xs' from 'XS/NumberValueRangeProcessor.xs' */


XS_EUPXS(XS_Search__Xapian__StringValueRangeProcessor_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__StringValueRangeProcessor_new)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "CLASS, valno, str = NO_INIT, prefix = true");
    {
	valueno	valno = (valueno)SvUV(ST(1))
;
	string	str;
	bool	prefix;
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	StringValueRangeProcessor *	RETVAL;

	if (items >= 3) {
	    {
		    STRLEN len;
		    const char * tmp = SvPV(ST(2), len);
		    str.assign(tmp, len);
	    }
;
	}

	if (items < 4)
	    prefix = true;
	else {
	    prefix = (bool)SvTRUE(ST(3))
;
	}
#line 11 "./XS/StringValueRangeProcessor.xs"
	switch (items) { /* items includes the hidden this pointer */
	case 2:
	    RETVAL = new StringValueRangeProcessor(valno);
	    break;
	case 3:
	case 4:
	    RETVAL = new StringValueRangeProcessor(valno, str, prefix);
	    break;
	default:
	    croak("Bad parameter count for new");
	}
#line 12701 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__StringValueRangeProcessor_process_value_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__StringValueRangeProcessor_process_value_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, begin, end");
    {
	string	begin;
	string	end;
	StringValueRangeProcessor *	THIS;
	valueno	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		begin.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		end.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (StringValueRangeProcessor *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::StringValueRangeProcessor::process_value_range() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 30 "./XS/StringValueRangeProcessor.xs"
		RETVAL = (*THIS)(begin, end);
#line 12749 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__StringValueRangeProcessor_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__StringValueRangeProcessor_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	StringValueRangeProcessor *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (StringValueRangeProcessor *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::StringValueRangeProcessor::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/NumberValueRangeProcessor.xs' from 'XS/StringValueRangeProcessor.xs' */


XS_EUPXS(XS_Search__Xapian__NumberValueRangeProcessor_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NumberValueRangeProcessor_new)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "CLASS, valno, str= NO_INIT, prefix= true");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	NumberValueRangeProcessor *	RETVAL;
	valueno	valno = (valueno)SvUV(ST(1))
;
	string	str;
	bool	prefix;

	if (items >= 3) {
	    {
		    STRLEN len;
		    const char * tmp = SvPV(ST(2), len);
		    str.assign(tmp, len);
	    }
;
	}

	if (items < 4)
	    prefix = true;
	else {
	    prefix = (bool)SvTRUE(ST(3))
;
	}
#line 8 "./XS/NumberValueRangeProcessor.xs"
	if (items == 2) {
	    RETVAL = new NumberValueRangeProcessor(valno);
	} else {
	    RETVAL = new NumberValueRangeProcessor(valno, str, prefix);
	}
#line 12819 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NumberValueRangeProcessor_process_value_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NumberValueRangeProcessor_process_value_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, begin, end");
    {
	string	begin;
	string	end;
	NumberValueRangeProcessor *	THIS;
	valueno	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		begin.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		end.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NumberValueRangeProcessor *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NumberValueRangeProcessor::process_value_range() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 21 "./XS/NumberValueRangeProcessor.xs"
		RETVAL = (*THIS)(begin, end);
#line 12867 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__NumberValueRangeProcessor_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__NumberValueRangeProcessor_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NumberValueRangeProcessor *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NumberValueRangeProcessor *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::NumberValueRangeProcessor::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'XS/DateValueRangeProcessor.xs' from 'XS/NumberValueRangeProcessor.xs' */


XS_EUPXS(XS_Search__Xapian__DateValueRangeProcessor_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DateValueRangeProcessor_new)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "CLASS, valno, prefer_mdy= false, epoch_year= 1970");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	DateValueRangeProcessor *	RETVAL;
	valueno	valno = (valueno)SvUV(ST(1))
;
	bool	prefer_mdy;
	int	epoch_year;

	if (items < 3)
	    prefer_mdy = false;
	else {
	    prefer_mdy = (bool)SvTRUE(ST(2))
;
	}

	if (items < 4)
	    epoch_year = 1970;
	else {
	    epoch_year = (int)SvIV(ST(3))
;
	}
#line 8 "./XS/DateValueRangeProcessor.xs"
	RETVAL = new DateValueRangeProcessor(valno, prefer_mdy, epoch_year);
#line 12931 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DateValueRangeProcessor_process_value_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DateValueRangeProcessor_process_value_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, begin, end");
    {
	string	begin;
	string	end;
	DateValueRangeProcessor *	THIS;
	valueno	RETVAL;
	dXSTARG;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(1), len);
		begin.assign(tmp, len);
	}
;

	{
		STRLEN len;
		const char * tmp = SvPV(ST(2), len);
		end.assign(tmp, len);
	}
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DateValueRangeProcessor *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DateValueRangeProcessor::process_value_range() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 17 "./XS/DateValueRangeProcessor.xs"
		RETVAL = (*THIS)(begin, end);
#line 12979 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__DateValueRangeProcessor_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__DateValueRangeProcessor_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	DateValueRangeProcessor *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (DateValueRangeProcessor *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::DateValueRangeProcessor::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'Xapian.xs' from 'XS/DateValueRangeProcessor.xs' */


/* INCLUDE:  Including 'XS/MatchSpy.xs' from 'Xapian.xs' */


/* INCLUDE:  Including 'XS/ValueCountMatchSpy.xs' from 'XS/MatchSpy.xs' */


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_new1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_new1)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	ValueCountMatchSpy *	RETVAL;
#line 8 "./XS/ValueCountMatchSpy.xs"
	RETVAL = new ValueCountMatchSpy();
#line 13029 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MatchSpy", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_new2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_new2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "slot");
    {
	valueno	slot = (valueno)SvUV(ST(0))
;
	ValueCountMatchSpy *	RETVAL;
#line 16 "./XS/ValueCountMatchSpy.xs"
	RETVAL = new ValueCountMatchSpy(slot);
#line 13053 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::MatchSpy", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueCountMatchSpy *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (ValueCountMatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueCountMatchSpy::DESTROY() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_get_total); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_get_total)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueCountMatchSpy *	THIS;
	size_t	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (ValueCountMatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueCountMatchSpy::get_total() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;
#line 26 "./XS/ValueCountMatchSpy.xs"
	try {
	    RETVAL = THIS->get_total();
	} catch (...) {
	    handle_exception();
	}
#line 13112 "Xapian.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_values_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_values_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueCountMatchSpy *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (ValueCountMatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueCountMatchSpy::values_begin() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;
#line 37 "./XS/ValueCountMatchSpy.xs"
	try {
	    RETVAL = new TermIterator(THIS->values_begin());
	} catch (...) {
	    handle_exception();
	}
#line 13143 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_values_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_values_end)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	ValueCountMatchSpy *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (ValueCountMatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueCountMatchSpy::values_end() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;
#line 48 "./XS/ValueCountMatchSpy.xs"
	try {
	    RETVAL = new TermIterator(THIS->values_end());
	} catch (...) {
	    handle_exception();
	}
#line 13178 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_top_values_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_top_values_begin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, maxvalues");
    {
	size_t	maxvalues = (size_t)SvUV(ST(1))
;
	ValueCountMatchSpy *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (ValueCountMatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueCountMatchSpy::top_values_begin() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;
#line 60 "./XS/ValueCountMatchSpy.xs"
	try {
	    RETVAL = new TermIterator(THIS->top_values_begin(maxvalues));
	} catch (...) {
	    handle_exception();
	}
#line 13215 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_top_values_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__ValueCountMatchSpy_top_values_end)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, maxvalues");
    {
	size_t	maxvalues = (size_t)SvUV(ST(1))
;
	ValueCountMatchSpy *	THIS;
	TermIterator *	RETVAL;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (ValueCountMatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::ValueCountMatchSpy::top_values_end() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;
#line 72 "./XS/ValueCountMatchSpy.xs"
	try {
	    RETVAL = new TermIterator(THIS->top_values_end(maxvalues));
	} catch (...) {
	    handle_exception();
	}
#line 13252 "Xapian.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Search::Xapian::TermIterator", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'XS/MatchSpy.xs' from 'XS/ValueCountMatchSpy.xs' */


XS_EUPXS(XS_Search__Xapian__MatchSpy_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MatchSpy_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MatchSpy *	THIS;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (MatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MatchSpy::DESTROY() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Search__Xapian__MatchSpy_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MatchSpy_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MatchSpy *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (MatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MatchSpy::name() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->name();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Search__Xapian__MatchSpy_get_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Search__Xapian__MatchSpy_get_description)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	MatchSpy *	THIS;
	string	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && sv_derived_from(ST(0), "Search::Xapian::MatchSpy") )
		THIS = (MatchSpy *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Search::Xapian::MatchSpy::get_description() -- THIS is not a \"Search::Xapian::MatchSpy\" object" );
		XSRETURN_UNDEF;
	}
;

	RETVAL = THIS->get_description();
	XSprePUSH;
	PUSHp((char *) (RETVAL.data()), (RETVAL.size()));
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'Xapian.xs' from 'XS/MatchSpy.xs' */

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Search__Xapian); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Search__Xapian)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Search::Xapian::sortable_serialise", XS_Search__Xapian_sortable_serialise, file, "$");
        (void)newXSproto_portable("Search::Xapian::sortable_unserialise", XS_Search__Xapian_sortable_unserialise, file, "$");
        (void)newXSproto_portable("Search::Xapian::version_string", XS_Search__Xapian_version_string, file, "");
        (void)newXSproto_portable("Search::Xapian::major_version", XS_Search__Xapian_major_version, file, "");
        (void)newXSproto_portable("Search::Xapian::minor_version", XS_Search__Xapian_minor_version, file, "");
        (void)newXSproto_portable("Search::Xapian::revision", XS_Search__Xapian_revision, file, "");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::new1", XS_Search__Xapian__WritableDatabase_new1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::new2", XS_Search__Xapian__WritableDatabase_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::new3", XS_Search__Xapian__WritableDatabase_new3, file, "");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::flush", XS_Search__Xapian__WritableDatabase_flush, file, "$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::commit", XS_Search__Xapian__WritableDatabase_commit, file, "$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::begin_transaction", XS_Search__Xapian__WritableDatabase_begin_transaction, file, "$;$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::commit_transaction", XS_Search__Xapian__WritableDatabase_commit_transaction, file, "$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::cancel_transaction", XS_Search__Xapian__WritableDatabase_cancel_transaction, file, "$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::add_document", XS_Search__Xapian__WritableDatabase_add_document, file, "$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::delete_document", XS_Search__Xapian__WritableDatabase_delete_document, file, "$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::delete_document_by_term", XS_Search__Xapian__WritableDatabase_delete_document_by_term, file, "$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::replace_document", XS_Search__Xapian__WritableDatabase_replace_document, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::replace_document_by_term", XS_Search__Xapian__WritableDatabase_replace_document_by_term, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::set_metadata", XS_Search__Xapian__WritableDatabase_set_metadata, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::DESTROY", XS_Search__Xapian__WritableDatabase_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::add_synonym", XS_Search__Xapian__WritableDatabase_add_synonym, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::remove_synonym", XS_Search__Xapian__WritableDatabase_remove_synonym, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::clear_synonyms", XS_Search__Xapian__WritableDatabase_clear_synonyms, file, "$$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::add_spelling", XS_Search__Xapian__WritableDatabase_add_spelling, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::WritableDatabase::remove_spelling", XS_Search__Xapian__WritableDatabase_remove_spelling, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::new1", XS_Search__Xapian__ValueIterator_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::new2", XS_Search__Xapian__ValueIterator_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::DESTROY", XS_Search__Xapian__ValueIterator_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::inc", XS_Search__Xapian__ValueIterator_inc, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::equal", XS_Search__Xapian__ValueIterator_equal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::nequal", XS_Search__Xapian__ValueIterator_nequal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::get_value", XS_Search__Xapian__ValueIterator_get_value, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::get_valueno", XS_Search__Xapian__ValueIterator_get_valueno, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueIterator::get_description", XS_Search__Xapian__ValueIterator_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::new1", XS_Search__Xapian__PositionIterator_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::new2", XS_Search__Xapian__PositionIterator_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::DESTROY", XS_Search__Xapian__PositionIterator_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::inc", XS_Search__Xapian__PositionIterator_inc, file, "$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::equal1", XS_Search__Xapian__PositionIterator_equal1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::nequal1", XS_Search__Xapian__PositionIterator_nequal1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::get_termpos", XS_Search__Xapian__PositionIterator_get_termpos, file, "$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::skip_to", XS_Search__Xapian__PositionIterator_skip_to, file, "$$");
        (void)newXSproto_portable("Search::Xapian::PositionIterator::get_description", XS_Search__Xapian__PositionIterator_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::new1", XS_Search__Xapian__PostingIterator_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::new2", XS_Search__Xapian__PostingIterator_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::DESTROY", XS_Search__Xapian__PostingIterator_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::inc", XS_Search__Xapian__PostingIterator_inc, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::equal1", XS_Search__Xapian__PostingIterator_equal1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::nequal1", XS_Search__Xapian__PostingIterator_nequal1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::get_docid", XS_Search__Xapian__PostingIterator_get_docid, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::get_doclength", XS_Search__Xapian__PostingIterator_get_doclength, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::get_wdf", XS_Search__Xapian__PostingIterator_get_wdf, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::get_description", XS_Search__Xapian__PostingIterator_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::positionlist_begin", XS_Search__Xapian__PostingIterator_positionlist_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::positionlist_end", XS_Search__Xapian__PostingIterator_positionlist_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::PostingIterator::skip_to", XS_Search__Xapian__PostingIterator_skip_to, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TradWeight::new1", XS_Search__Xapian__TradWeight_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::TradWeight::new2", XS_Search__Xapian__TradWeight_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::TradWeight::DESTROY", XS_Search__Xapian__TradWeight_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::new1", XS_Search__Xapian__TermIterator_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::TermIterator::new2", XS_Search__Xapian__TermIterator_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::DESTROY", XS_Search__Xapian__TermIterator_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::inc", XS_Search__Xapian__TermIterator_inc, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::equal", XS_Search__Xapian__TermIterator_equal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::nequal", XS_Search__Xapian__TermIterator_nequal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::get_termname", XS_Search__Xapian__TermIterator_get_termname, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::skip_to", XS_Search__Xapian__TermIterator_skip_to, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::get_wdf", XS_Search__Xapian__TermIterator_get_wdf, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::get_termfreq", XS_Search__Xapian__TermIterator_get_termfreq, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::positionlist_begin", XS_Search__Xapian__TermIterator_positionlist_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::positionlist_end", XS_Search__Xapian__TermIterator_positionlist_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermIterator::get_description", XS_Search__Xapian__TermIterator_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::new0", XS_Search__Xapian__TermGenerator_new0, file, "");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::set_stemmer", XS_Search__Xapian__TermGenerator_set_stemmer, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::set_stopper", XS_Search__Xapian__TermGenerator_set_stopper, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::set_database", XS_Search__Xapian__TermGenerator_set_database, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::set_document", XS_Search__Xapian__TermGenerator_set_document, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::get_document", XS_Search__Xapian__TermGenerator_get_document, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::index_text", XS_Search__Xapian__TermGenerator_index_text, file, "$$;$$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::set_flags", XS_Search__Xapian__TermGenerator_set_flags, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::index_text_without_positions", XS_Search__Xapian__TermGenerator_index_text_without_positions, file, "$$;$$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::increase_termpos", XS_Search__Xapian__TermGenerator_increase_termpos, file, "$;$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::get_termpos", XS_Search__Xapian__TermGenerator_get_termpos, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::set_termpos", XS_Search__Xapian__TermGenerator_set_termpos, file, "$$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::get_description", XS_Search__Xapian__TermGenerator_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::TermGenerator::DESTROY", XS_Search__Xapian__TermGenerator_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::Stopper::stop_word", XS_Search__Xapian__Stopper_stop_word, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Stopper::DESTROY", XS_Search__Xapian__Stopper_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::Stem::new", XS_Search__Xapian__Stem_new, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Stem::stem_word", XS_Search__Xapian__Stem_stem_word, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Stem::get_description", XS_Search__Xapian__Stem_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::Stem::DESTROY", XS_Search__Xapian__Stem_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::SimpleStopper::new0", XS_Search__Xapian__SimpleStopper_new0, file, "");
        (void)newXSproto_portable("Search::Xapian::SimpleStopper::stop_word", XS_Search__Xapian__SimpleStopper_stop_word, file, "$$");
        (void)newXSproto_portable("Search::Xapian::SimpleStopper::add", XS_Search__Xapian__SimpleStopper_add, file, "$$");
        (void)newXSproto_portable("Search::Xapian::SimpleStopper::DESTROY", XS_Search__Xapian__SimpleStopper_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::new0", XS_Search__Xapian__QueryParser_new0, file, "");
        (void)newXSproto_portable("Search::Xapian::QueryParser::set_stemmer", XS_Search__Xapian__QueryParser_set_stemmer, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::set_stemming_strategy", XS_Search__Xapian__QueryParser_set_stemming_strategy, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::set_stopper", XS_Search__Xapian__QueryParser_set_stopper, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::set_default_op", XS_Search__Xapian__QueryParser_set_default_op, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::get_default_op", XS_Search__Xapian__QueryParser_get_default_op, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::set_database", XS_Search__Xapian__QueryParser_set_database, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::set_max_wildcard_expansion", XS_Search__Xapian__QueryParser_set_max_wildcard_expansion, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::parse_query", XS_Search__Xapian__QueryParser_parse_query, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::add_prefix", XS_Search__Xapian__QueryParser_add_prefix, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::add_boolean_prefix", XS_Search__Xapian__QueryParser_add_boolean_prefix, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::stoplist_begin", XS_Search__Xapian__QueryParser_stoplist_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::stoplist_end", XS_Search__Xapian__QueryParser_stoplist_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::unstem_begin", XS_Search__Xapian__QueryParser_unstem_begin, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::unstem_end", XS_Search__Xapian__QueryParser_unstem_end, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::get_corrected_query_string", XS_Search__Xapian__QueryParser_get_corrected_query_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::get_description", XS_Search__Xapian__QueryParser_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::add_valuerangeprocessor", XS_Search__Xapian__QueryParser_add_valuerangeprocessor, file, "$$");
        (void)newXSproto_portable("Search::Xapian::QueryParser::DESTROY", XS_Search__Xapian__QueryParser_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::Query::new0", XS_Search__Xapian__Query_new0, file, "");
        (void)newXSproto_portable("Search::Xapian::Query::new1", XS_Search__Xapian__Query_new1, file, "$");
        (void)newXSproto_portable("Search::Xapian::Query::new1weight", XS_Search__Xapian__Query_new1weight, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::Query::new3scale", XS_Search__Xapian__Query_new3scale, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::Query::new3range", XS_Search__Xapian__Query_new3range, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::Query::new4range", XS_Search__Xapian__Query_new4range, file, "$$$$");
        (void)newXSproto_portable("Search::Xapian::Query::newN", XS_Search__Xapian__Query_newN, file, "$;@");
        (void)newXSproto_portable("Search::Xapian::Query::get_length", XS_Search__Xapian__Query_get_length, file, "$");
        (void)newXSproto_portable("Search::Xapian::Query::get_terms_begin", XS_Search__Xapian__Query_get_terms_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::Query::get_terms_end", XS_Search__Xapian__Query_get_terms_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::Query::empty", XS_Search__Xapian__Query_empty, file, "$");
        (void)newXSproto_portable("Search::Xapian::Query::get_description", XS_Search__Xapian__Query_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::Query::DESTROY", XS_Search__Xapian__Query_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::MultiValueSorter::new0", XS_Search__Xapian__MultiValueSorter_new0, file, "");
        (void)newXSproto_portable("Search::Xapian::MultiValueSorter::add", XS_Search__Xapian__MultiValueSorter_add, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::MultiValueSorter::DESTROY", XS_Search__Xapian__MultiValueSorter_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::RSet::new1", XS_Search__Xapian__RSet_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::RSet::new2", XS_Search__Xapian__RSet_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::RSet::size", XS_Search__Xapian__RSet_size, file, "$");
        (void)newXSproto_portable("Search::Xapian::RSet::empty", XS_Search__Xapian__RSet_empty, file, "$");
        (void)newXSproto_portable("Search::Xapian::RSet::add_document1", XS_Search__Xapian__RSet_add_document1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::RSet::add_document2", XS_Search__Xapian__RSet_add_document2, file, "$$");
        (void)newXSproto_portable("Search::Xapian::RSet::remove_document1", XS_Search__Xapian__RSet_remove_document1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::RSet::remove_document2", XS_Search__Xapian__RSet_remove_document2, file, "$$");
        (void)newXSproto_portable("Search::Xapian::RSet::contains1", XS_Search__Xapian__RSet_contains1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::RSet::contains2", XS_Search__Xapian__RSet_contains2, file, "$$");
        (void)newXSproto_portable("Search::Xapian::RSet::get_description", XS_Search__Xapian__RSet_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::RSet::DESTROY", XS_Search__Xapian__RSet_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::new1", XS_Search__Xapian__ESetIterator_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::new2", XS_Search__Xapian__ESetIterator_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::inc", XS_Search__Xapian__ESetIterator_inc, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::dec", XS_Search__Xapian__ESetIterator_dec, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::equal", XS_Search__Xapian__ESetIterator_equal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::nequal", XS_Search__Xapian__ESetIterator_nequal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::get_termname", XS_Search__Xapian__ESetIterator_get_termname, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::get_weight", XS_Search__Xapian__ESetIterator_get_weight, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::get_description", XS_Search__Xapian__ESetIterator_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESetIterator::DESTROY", XS_Search__Xapian__ESetIterator_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::Error::get_type", XS_Search__Xapian__Error_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::Error::get_msg", XS_Search__Xapian__Error_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::Error::get_context", XS_Search__Xapian__Error_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::Error::get_error_string", XS_Search__Xapian__Error_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::Error::DESTROY", XS_Search__Xapian__Error_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::RuntimeError::get_type", XS_Search__Xapian__RuntimeError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::RuntimeError::get_msg", XS_Search__Xapian__RuntimeError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::RuntimeError::get_context", XS_Search__Xapian__RuntimeError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::RuntimeError::get_error_string", XS_Search__Xapian__RuntimeError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::RuntimeError::DESTROY", XS_Search__Xapian__RuntimeError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::WildcardError::get_type", XS_Search__Xapian__WildcardError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::WildcardError::get_msg", XS_Search__Xapian__WildcardError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::WildcardError::get_context", XS_Search__Xapian__WildcardError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::WildcardError::get_error_string", XS_Search__Xapian__WildcardError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::WildcardError::DESTROY", XS_Search__Xapian__WildcardError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::RangeError::get_type", XS_Search__Xapian__RangeError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::RangeError::get_msg", XS_Search__Xapian__RangeError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::RangeError::get_context", XS_Search__Xapian__RangeError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::RangeError::get_error_string", XS_Search__Xapian__RangeError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::RangeError::DESTROY", XS_Search__Xapian__RangeError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::SerialisationError::get_type", XS_Search__Xapian__SerialisationError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::SerialisationError::get_msg", XS_Search__Xapian__SerialisationError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::SerialisationError::get_context", XS_Search__Xapian__SerialisationError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::SerialisationError::get_error_string", XS_Search__Xapian__SerialisationError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::SerialisationError::DESTROY", XS_Search__Xapian__SerialisationError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParserError::get_type", XS_Search__Xapian__QueryParserError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParserError::get_msg", XS_Search__Xapian__QueryParserError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParserError::get_context", XS_Search__Xapian__QueryParserError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParserError::get_error_string", XS_Search__Xapian__QueryParserError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::QueryParserError::DESTROY", XS_Search__Xapian__QueryParserError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkError::get_type", XS_Search__Xapian__NetworkError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkError::get_msg", XS_Search__Xapian__NetworkError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkError::get_context", XS_Search__Xapian__NetworkError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkError::get_error_string", XS_Search__Xapian__NetworkError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkError::DESTROY", XS_Search__Xapian__NetworkError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkTimeoutError::get_type", XS_Search__Xapian__NetworkTimeoutError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkTimeoutError::get_msg", XS_Search__Xapian__NetworkTimeoutError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkTimeoutError::get_context", XS_Search__Xapian__NetworkTimeoutError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkTimeoutError::get_error_string", XS_Search__Xapian__NetworkTimeoutError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::NetworkTimeoutError::DESTROY", XS_Search__Xapian__NetworkTimeoutError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::InternalError::get_type", XS_Search__Xapian__InternalError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::InternalError::get_msg", XS_Search__Xapian__InternalError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::InternalError::get_context", XS_Search__Xapian__InternalError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::InternalError::get_error_string", XS_Search__Xapian__InternalError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::InternalError::DESTROY", XS_Search__Xapian__InternalError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::FeatureUnavailableError::get_type", XS_Search__Xapian__FeatureUnavailableError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::FeatureUnavailableError::get_msg", XS_Search__Xapian__FeatureUnavailableError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::FeatureUnavailableError::get_context", XS_Search__Xapian__FeatureUnavailableError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::FeatureUnavailableError::get_error_string", XS_Search__Xapian__FeatureUnavailableError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::FeatureUnavailableError::DESTROY", XS_Search__Xapian__FeatureUnavailableError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DocNotFoundError::get_type", XS_Search__Xapian__DocNotFoundError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DocNotFoundError::get_msg", XS_Search__Xapian__DocNotFoundError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DocNotFoundError::get_context", XS_Search__Xapian__DocNotFoundError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DocNotFoundError::get_error_string", XS_Search__Xapian__DocNotFoundError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DocNotFoundError::DESTROY", XS_Search__Xapian__DocNotFoundError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseError::get_type", XS_Search__Xapian__DatabaseError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseError::get_msg", XS_Search__Xapian__DatabaseError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseError::get_context", XS_Search__Xapian__DatabaseError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseError::get_error_string", XS_Search__Xapian__DatabaseError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseError::DESTROY", XS_Search__Xapian__DatabaseError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseOpeningError::get_type", XS_Search__Xapian__DatabaseOpeningError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseOpeningError::get_msg", XS_Search__Xapian__DatabaseOpeningError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseOpeningError::get_context", XS_Search__Xapian__DatabaseOpeningError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseOpeningError::get_error_string", XS_Search__Xapian__DatabaseOpeningError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseOpeningError::DESTROY", XS_Search__Xapian__DatabaseOpeningError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseVersionError::get_type", XS_Search__Xapian__DatabaseVersionError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseVersionError::get_msg", XS_Search__Xapian__DatabaseVersionError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseVersionError::get_context", XS_Search__Xapian__DatabaseVersionError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseVersionError::get_error_string", XS_Search__Xapian__DatabaseVersionError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseVersionError::DESTROY", XS_Search__Xapian__DatabaseVersionError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseModifiedError::get_type", XS_Search__Xapian__DatabaseModifiedError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseModifiedError::get_msg", XS_Search__Xapian__DatabaseModifiedError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseModifiedError::get_context", XS_Search__Xapian__DatabaseModifiedError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseModifiedError::get_error_string", XS_Search__Xapian__DatabaseModifiedError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseModifiedError::DESTROY", XS_Search__Xapian__DatabaseModifiedError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseLockError::get_type", XS_Search__Xapian__DatabaseLockError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseLockError::get_msg", XS_Search__Xapian__DatabaseLockError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseLockError::get_context", XS_Search__Xapian__DatabaseLockError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseLockError::get_error_string", XS_Search__Xapian__DatabaseLockError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseLockError::DESTROY", XS_Search__Xapian__DatabaseLockError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCreateError::get_type", XS_Search__Xapian__DatabaseCreateError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCreateError::get_msg", XS_Search__Xapian__DatabaseCreateError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCreateError::get_context", XS_Search__Xapian__DatabaseCreateError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCreateError::get_error_string", XS_Search__Xapian__DatabaseCreateError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCreateError::DESTROY", XS_Search__Xapian__DatabaseCreateError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCorruptError::get_type", XS_Search__Xapian__DatabaseCorruptError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCorruptError::get_msg", XS_Search__Xapian__DatabaseCorruptError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCorruptError::get_context", XS_Search__Xapian__DatabaseCorruptError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCorruptError::get_error_string", XS_Search__Xapian__DatabaseCorruptError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::DatabaseCorruptError::DESTROY", XS_Search__Xapian__DatabaseCorruptError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::LogicError::get_type", XS_Search__Xapian__LogicError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::LogicError::get_msg", XS_Search__Xapian__LogicError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::LogicError::get_context", XS_Search__Xapian__LogicError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::LogicError::get_error_string", XS_Search__Xapian__LogicError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::LogicError::DESTROY", XS_Search__Xapian__LogicError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::UnimplementedError::get_type", XS_Search__Xapian__UnimplementedError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::UnimplementedError::get_msg", XS_Search__Xapian__UnimplementedError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::UnimplementedError::get_context", XS_Search__Xapian__UnimplementedError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::UnimplementedError::get_error_string", XS_Search__Xapian__UnimplementedError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::UnimplementedError::DESTROY", XS_Search__Xapian__UnimplementedError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidOperationError::get_type", XS_Search__Xapian__InvalidOperationError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidOperationError::get_msg", XS_Search__Xapian__InvalidOperationError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidOperationError::get_context", XS_Search__Xapian__InvalidOperationError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidOperationError::get_error_string", XS_Search__Xapian__InvalidOperationError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidOperationError::DESTROY", XS_Search__Xapian__InvalidOperationError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidArgumentError::get_type", XS_Search__Xapian__InvalidArgumentError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidArgumentError::get_msg", XS_Search__Xapian__InvalidArgumentError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidArgumentError::get_context", XS_Search__Xapian__InvalidArgumentError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidArgumentError::get_error_string", XS_Search__Xapian__InvalidArgumentError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::InvalidArgumentError::DESTROY", XS_Search__Xapian__InvalidArgumentError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::AssertionError::get_type", XS_Search__Xapian__AssertionError_get_type, file, "$");
        (void)newXSproto_portable("Search::Xapian::AssertionError::get_msg", XS_Search__Xapian__AssertionError_get_msg, file, "$");
        (void)newXSproto_portable("Search::Xapian::AssertionError::get_context", XS_Search__Xapian__AssertionError_get_context, file, "$");
        (void)newXSproto_portable("Search::Xapian::AssertionError::get_error_string", XS_Search__Xapian__AssertionError_get_error_string, file, "$");
        (void)newXSproto_portable("Search::Xapian::AssertionError::DESTROY", XS_Search__Xapian__AssertionError_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESet::new1", XS_Search__Xapian__ESet_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::ESet::new2", XS_Search__Xapian__ESet_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESet::get_ebound", XS_Search__Xapian__ESet_get_ebound, file, "$");
        cv = newXSproto_portable("Search::Xapian::ESet::FETCHSIZE", XS_Search__Xapian__ESet_size, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Search::Xapian::ESet::size", XS_Search__Xapian__ESet_size, file, "$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Search::Xapian::ESet::empty", XS_Search__Xapian__ESet_empty, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESet::begin", XS_Search__Xapian__ESet_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESet::end", XS_Search__Xapian__ESet_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESet::back", XS_Search__Xapian__ESet_back, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESet::FETCH", XS_Search__Xapian__ESet_FETCH, file, "$$");
        (void)newXSproto_portable("Search::Xapian::ESet::get_description", XS_Search__Xapian__ESet_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::ESet::DESTROY", XS_Search__Xapian__ESet_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::new1", XS_Search__Xapian__MSetIterator_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::new2", XS_Search__Xapian__MSetIterator_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::inc", XS_Search__Xapian__MSetIterator_inc, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::dec", XS_Search__Xapian__MSetIterator_dec, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::equal", XS_Search__Xapian__MSetIterator_equal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::nequal", XS_Search__Xapian__MSetIterator_nequal, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::get_docid", XS_Search__Xapian__MSetIterator_get_docid, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::get_document", XS_Search__Xapian__MSetIterator_get_document, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::get_rank", XS_Search__Xapian__MSetIterator_get_rank, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::get_weight", XS_Search__Xapian__MSetIterator_get_weight, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::get_collapse_count", XS_Search__Xapian__MSetIterator_get_collapse_count, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::get_percent", XS_Search__Xapian__MSetIterator_get_percent, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::get_description", XS_Search__Xapian__MSetIterator_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSetIterator::DESTROY", XS_Search__Xapian__MSetIterator_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::new1", XS_Search__Xapian__MSet_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::MSet::new2", XS_Search__Xapian__MSet_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::fetch1", XS_Search__Xapian__MSet_fetch1, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::MSet::fetch2", XS_Search__Xapian__MSet_fetch2, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSet::fetch3", XS_Search__Xapian__MSet_fetch3, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::convert_to_percent1", XS_Search__Xapian__MSet_convert_to_percent1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSet::convert_to_percent2", XS_Search__Xapian__MSet_convert_to_percent2, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_termfreq", XS_Search__Xapian__MSet_get_termfreq, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_termweight", XS_Search__Xapian__MSet_get_termweight, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_firstitem", XS_Search__Xapian__MSet_get_firstitem, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_matches_lower_bound", XS_Search__Xapian__MSet_get_matches_lower_bound, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_matches_estimated", XS_Search__Xapian__MSet_get_matches_estimated, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_matches_upper_bound", XS_Search__Xapian__MSet_get_matches_upper_bound, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_max_possible", XS_Search__Xapian__MSet_get_max_possible, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::get_max_attained", XS_Search__Xapian__MSet_get_max_attained, file, "$");
        cv = newXSproto_portable("Search::Xapian::MSet::FETCHSIZE", XS_Search__Xapian__MSet_size, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("Search::Xapian::MSet::size", XS_Search__Xapian__MSet_size, file, "$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Search::Xapian::MSet::empty", XS_Search__Xapian__MSet_empty, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::swap", XS_Search__Xapian__MSet_swap, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MSet::begin", XS_Search__Xapian__MSet_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::end", XS_Search__Xapian__MSet_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::back", XS_Search__Xapian__MSet_back, file, "$");
        cv = newXSproto_portable("Search::Xapian::MSet::FETCH", XS_Search__Xapian__MSet_FETCH, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Search::Xapian::MSet::get_msetiterator", XS_Search__Xapian__MSet_FETCH, file, "$$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Search::Xapian::MSet::get_description", XS_Search__Xapian__MSet_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::MSet::DESTROY", XS_Search__Xapian__MSet_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::Enquire::new", XS_Search__Xapian__Enquire_new, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_query1", XS_Search__Xapian__Enquire_set_query1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_query2", XS_Search__Xapian__Enquire_set_query2, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_query", XS_Search__Xapian__Enquire_get_query, file, "$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_collapse_key", XS_Search__Xapian__Enquire_set_collapse_key, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_docid_order", XS_Search__Xapian__Enquire_set_docid_order, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_cutoff", XS_Search__Xapian__Enquire_set_cutoff, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_sort_by_relevance", XS_Search__Xapian__Enquire_set_sort_by_relevance, file, "$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_sort_by_value", XS_Search__Xapian__Enquire_set_sort_by_value, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_sort_by_value_then_relevance", XS_Search__Xapian__Enquire_set_sort_by_value_then_relevance, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_sort_by_relevance_then_value", XS_Search__Xapian__Enquire_set_sort_by_relevance_then_value, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_sort_by_key", XS_Search__Xapian__Enquire_set_sort_by_key, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_sort_by_key_then_relevance", XS_Search__Xapian__Enquire_set_sort_by_key_then_relevance, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_sort_by_relevance_then_key", XS_Search__Xapian__Enquire_set_sort_by_relevance_then_key, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_mset1", XS_Search__Xapian__Enquire_get_mset1, file, "$$$;$$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_mset2", XS_Search__Xapian__Enquire_get_mset2, file, "$$$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_eset", XS_Search__Xapian__Enquire_get_eset, file, "$$$;$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_matching_terms_begin1", XS_Search__Xapian__Enquire_get_matching_terms_begin1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_matching_terms_begin2", XS_Search__Xapian__Enquire_get_matching_terms_begin2, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_matching_terms_end1", XS_Search__Xapian__Enquire_get_matching_terms_end1, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_matching_terms_end2", XS_Search__Xapian__Enquire_get_matching_terms_end2, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::set_weighting_scheme", XS_Search__Xapian__Enquire_set_weighting_scheme, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::get_description", XS_Search__Xapian__Enquire_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::Enquire::add_matchspy", XS_Search__Xapian__Enquire_add_matchspy, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Enquire::clear_matchspies", XS_Search__Xapian__Enquire_clear_matchspies, file, "$");
        (void)newXSproto_portable("Search::Xapian::Enquire::DESTROY", XS_Search__Xapian__Enquire_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::new1", XS_Search__Xapian__Document_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::Document::new2", XS_Search__Xapian__Document_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::get_value", XS_Search__Xapian__Document_get_value, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Document::add_value", XS_Search__Xapian__Document_add_value, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::Document::remove_value", XS_Search__Xapian__Document_remove_value, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Document::clear_values", XS_Search__Xapian__Document_clear_values, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::get_data", XS_Search__Xapian__Document_get_data, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::set_data", XS_Search__Xapian__Document_set_data, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Document::add_posting", XS_Search__Xapian__Document_add_posting, file, "$$$;$");
        (void)newXSproto_portable("Search::Xapian::Document::add_term", XS_Search__Xapian__Document_add_term, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Document::add_boolean_term", XS_Search__Xapian__Document_add_boolean_term, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Document::remove_posting", XS_Search__Xapian__Document_remove_posting, file, "$$$;$");
        (void)newXSproto_portable("Search::Xapian::Document::remove_term", XS_Search__Xapian__Document_remove_term, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Document::clear_terms", XS_Search__Xapian__Document_clear_terms, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::termlist_count", XS_Search__Xapian__Document_termlist_count, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::termlist_begin", XS_Search__Xapian__Document_termlist_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::termlist_end", XS_Search__Xapian__Document_termlist_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::values_count", XS_Search__Xapian__Document_values_count, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::values_begin", XS_Search__Xapian__Document_values_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::values_end", XS_Search__Xapian__Document_values_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::get_docid", XS_Search__Xapian__Document_get_docid, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::get_description", XS_Search__Xapian__Document_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::Document::DESTROY", XS_Search__Xapian__Document_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::new1", XS_Search__Xapian__Database_new1, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::new2", XS_Search__Xapian__Database_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::add_database", XS_Search__Xapian__Database_add_database, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::reopen", XS_Search__Xapian__Database_reopen, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::get_description", XS_Search__Xapian__Database_get_description, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::termlist_begin", XS_Search__Xapian__Database_termlist_begin, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::termlist_end", XS_Search__Xapian__Database_termlist_end, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::positionlist_begin", XS_Search__Xapian__Database_positionlist_begin, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::Database::positionlist_end", XS_Search__Xapian__Database_positionlist_end, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::Database::allterms_begin", XS_Search__Xapian__Database_allterms_begin, file, "$;$");
        (void)newXSproto_portable("Search::Xapian::Database::allterms_end", XS_Search__Xapian__Database_allterms_end, file, "$;$");
        (void)newXSproto_portable("Search::Xapian::Database::postlist_begin", XS_Search__Xapian__Database_postlist_begin, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::postlist_end", XS_Search__Xapian__Database_postlist_end, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::get_doccount", XS_Search__Xapian__Database_get_doccount, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::get_lastdocid", XS_Search__Xapian__Database_get_lastdocid, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::get_avlength", XS_Search__Xapian__Database_get_avlength, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::get_termfreq", XS_Search__Xapian__Database_get_termfreq, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::term_exists", XS_Search__Xapian__Database_term_exists, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::get_collection_freq", XS_Search__Xapian__Database_get_collection_freq, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::get_doclength", XS_Search__Xapian__Database_get_doclength, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::keep_alive", XS_Search__Xapian__Database_keep_alive, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::get_document", XS_Search__Xapian__Database_get_document, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::get_spelling_suggestion", XS_Search__Xapian__Database_get_spelling_suggestion, file, "$$;$");
        (void)newXSproto_portable("Search::Xapian::Database::get_metadata", XS_Search__Xapian__Database_get_metadata, file, "$$");
        (void)newXSproto_portable("Search::Xapian::Database::close", XS_Search__Xapian__Database_close, file, "$");
        (void)newXSproto_portable("Search::Xapian::Database::DESTROY", XS_Search__Xapian__Database_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::BoolWeight::new1", XS_Search__Xapian__BoolWeight_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::BoolWeight::DESTROY", XS_Search__Xapian__BoolWeight_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::BM25Weight::new1", XS_Search__Xapian__BM25Weight_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::BM25Weight::new2", XS_Search__Xapian__BM25Weight_new2, file, "$$$$$");
        (void)newXSproto_portable("Search::Xapian::BM25Weight::DESTROY", XS_Search__Xapian__BM25Weight_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::StringValueRangeProcessor::new", XS_Search__Xapian__StringValueRangeProcessor_new, file, "$$;$$");
        (void)newXSproto_portable("Search::Xapian::StringValueRangeProcessor::process_value_range", XS_Search__Xapian__StringValueRangeProcessor_process_value_range, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::StringValueRangeProcessor::DESTROY", XS_Search__Xapian__StringValueRangeProcessor_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::NumberValueRangeProcessor::new", XS_Search__Xapian__NumberValueRangeProcessor_new, file, "$$;$$");
        (void)newXSproto_portable("Search::Xapian::NumberValueRangeProcessor::process_value_range", XS_Search__Xapian__NumberValueRangeProcessor_process_value_range, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::NumberValueRangeProcessor::DESTROY", XS_Search__Xapian__NumberValueRangeProcessor_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::DateValueRangeProcessor::new", XS_Search__Xapian__DateValueRangeProcessor_new, file, "$$;$$");
        (void)newXSproto_portable("Search::Xapian::DateValueRangeProcessor::process_value_range", XS_Search__Xapian__DateValueRangeProcessor_process_value_range, file, "$$$");
        (void)newXSproto_portable("Search::Xapian::DateValueRangeProcessor::DESTROY", XS_Search__Xapian__DateValueRangeProcessor_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::new1", XS_Search__Xapian__ValueCountMatchSpy_new1, file, "");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::new2", XS_Search__Xapian__ValueCountMatchSpy_new2, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::DESTROY", XS_Search__Xapian__ValueCountMatchSpy_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::get_total", XS_Search__Xapian__ValueCountMatchSpy_get_total, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::values_begin", XS_Search__Xapian__ValueCountMatchSpy_values_begin, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::values_end", XS_Search__Xapian__ValueCountMatchSpy_values_end, file, "$");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::top_values_begin", XS_Search__Xapian__ValueCountMatchSpy_top_values_begin, file, "$$");
        (void)newXSproto_portable("Search::Xapian::ValueCountMatchSpy::top_values_end", XS_Search__Xapian__ValueCountMatchSpy_top_values_end, file, "$$");
        (void)newXSproto_portable("Search::Xapian::MatchSpy::DESTROY", XS_Search__Xapian__MatchSpy_DESTROY, file, "$");
        (void)newXSproto_portable("Search::Xapian::MatchSpy::name", XS_Search__Xapian__MatchSpy_name, file, "$");
        (void)newXSproto_portable("Search::Xapian::MatchSpy::get_description", XS_Search__Xapian__MatchSpy_get_description, file, "$");

    /* Initialisation Section */

#line 306 "Xapian.xs"
    {
	HV *mHvStash = gv_stashpv( "Search::Xapian", TRUE );
// Perl >= probably 5.10 doesn't need the const_cast<> here.
#define ENUM_CONST(P, C) newCONSTSUB( mHvStash, const_cast<char*>(#P), newSViv(C) )

	ENUM_CONST(OP_AND, Query::OP_AND);
	ENUM_CONST(OP_OR, Query::OP_OR);
	ENUM_CONST(OP_AND_NOT, Query::OP_AND_NOT);
	ENUM_CONST(OP_XOR, Query::OP_XOR);
	ENUM_CONST(OP_AND_MAYBE, Query::OP_AND_MAYBE);
	ENUM_CONST(OP_FILTER, Query::OP_FILTER);
	ENUM_CONST(OP_NEAR, Query::OP_NEAR);
	ENUM_CONST(OP_PHRASE, Query::OP_PHRASE);
	ENUM_CONST(OP_VALUE_RANGE, Query::OP_VALUE_RANGE);
	ENUM_CONST(OP_SCALE_WEIGHT, Query::OP_SCALE_WEIGHT);
	ENUM_CONST(OP_ELITE_SET, Query::OP_ELITE_SET);
	ENUM_CONST(OP_VALUE_GE, Query::OP_VALUE_GE);
	ENUM_CONST(OP_VALUE_LE, Query::OP_VALUE_LE);

	ENUM_CONST(DB_OPEN, DB_OPEN);
	ENUM_CONST(DB_CREATE, DB_CREATE);
	ENUM_CONST(DB_CREATE_OR_OPEN, DB_CREATE_OR_OPEN);
	ENUM_CONST(DB_CREATE_OR_OVERWRITE, DB_CREATE_OR_OVERWRITE);

	ENUM_CONST(ENQ_DESCENDING, Enquire::DESCENDING);
	ENUM_CONST(ENQ_ASCENDING, Enquire::ASCENDING);
	ENUM_CONST(ENQ_DONT_CARE, Enquire::DONT_CARE);

	ENUM_CONST(FLAG_BOOLEAN, QueryParser::FLAG_BOOLEAN);
	ENUM_CONST(FLAG_PHRASE, QueryParser::FLAG_PHRASE);
	ENUM_CONST(FLAG_LOVEHATE, QueryParser::FLAG_LOVEHATE);
	ENUM_CONST(FLAG_BOOLEAN_ANY_CASE, QueryParser::FLAG_BOOLEAN_ANY_CASE);
	ENUM_CONST(FLAG_WILDCARD, QueryParser::FLAG_WILDCARD);
	ENUM_CONST(FLAG_PURE_NOT, QueryParser::FLAG_PURE_NOT);
	ENUM_CONST(FLAG_PARTIAL, QueryParser::FLAG_PARTIAL);
	ENUM_CONST(FLAG_SPELLING_CORRECTION, QueryParser::FLAG_SPELLING_CORRECTION);
	ENUM_CONST(FLAG_SYNONYM, QueryParser::FLAG_SYNONYM);
	ENUM_CONST(FLAG_AUTO_SYNONYMS, QueryParser::FLAG_AUTO_SYNONYMS);
	ENUM_CONST(FLAG_AUTO_MULTIWORD_SYNONYMS, QueryParser::FLAG_AUTO_SYNONYMS);
	ENUM_CONST(FLAG_DEFAULT, QueryParser::FLAG_DEFAULT);

	ENUM_CONST(STEM_NONE, QueryParser::STEM_NONE);
	ENUM_CONST(STEM_SOME, QueryParser::STEM_SOME);
	ENUM_CONST(STEM_ALL, QueryParser::STEM_ALL);

	ENUM_CONST(FLAG_SPELLING, TermGenerator::FLAG_SPELLING);

	ENUM_CONST(BAD_VALUENO, BAD_VALUENO);
    }

#line 13855 "Xapian.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
